classdef Analysis_Critical_Bands < matlab.apps.AppBase

    % Properties that correspond to app components
    properties (Access = public)
        UIFigure                     matlab.ui.Figure
        SerranoPedrazaI2023Label     matlab.ui.control.Label
        ResetButton_2                matlab.ui.control.Button
        ResetButton                  matlab.ui.control.Button
        ExamplesButton               matlab.ui.control.Button
        RemovefittingButton_2000     matlab.ui.control.Button
        FitmodelButton_2000          matlab.ui.control.Button
        UITable_2                    matlab.ui.control.Table
        RemovefittingButton_500      matlab.ui.control.Button
        FitmodelButton_500           matlab.ui.control.Button
        UITable                      matlab.ui.control.Table
        CriticalbandestimationLabel  matlab.ui.control.Label
        UIAxes_2                     matlab.ui.control.UIAxes
        UIAxes                       matlab.ui.control.UIAxes
    end

    
    properties (Access = private)
        CallingApp; % Main app 
        Indices; % Description
        B25_500=0;
        B50_500=0;
        B75_500=0;
        B100_500=0;
        B150_500=0;
        B200_500=0;
        B300_500=0;
        B400_500=0;
        B500_500=0;
                
        

       
        B50_2000=0;
        B100_2000=0;
        B200_2000=0;
        B250_2000=0;
        B300_2000=0;
        B400_2000=0;
        B600_2000=0;
        B800_2000=0;
        B1600_2000=0;

        bandwidth_500=[25 50 75 100 150 200 300 400 500];
        fitmodel_500=0;
        frequency_500=500;
        ordenada_500=0;
        Critical_Band_500=0;
        exponent_500=0;
        bandwidth_2000=[50 100 200 250 300 400 600 800 1600];
        fitmodel_2000=0;
        frequency_2000=2000;
        ordenada_2000=0;
        Critical_Band_2000=0;
        exponent_2000=0;
        freq=linspace(0, 3000, 1000);
    end
    
    methods (Access = private)
  


            function updateplot(app)
            
            %%%Dr. Ignacio Serrano-Pedraza 2023
            %%%With this program you can analyze the data from the
            %%%experiment Experiment_Critical_Bands.m


            parameters_500=[app.ordenada_500 app.Critical_Band_500 app.exponent_500];

            % Get Table UI component data
            t = app.UITable.DisplayData;            
            app.B25_500=t.Var1;
            app.B50_500=t.Var2;
            app.B75_500=t.Var3;
            app.B100_500=t.Var4;
            app.B150_500=t.Var5;
            app.B200_500=t.Var6;
            app.B300_500=t.Var7;
            app.B400_500=t.Var8;
            app.B500_500=t.Var9;
         % app.UITable.RowName={'Thresholds (500Hz)'};
          T=table(app.B25_500,app.B50_500,app.B75_500,app.B100_500,app.B150_500,app.B200_500,app.B300_500,app.B400_500,app.B500_500);
          app.UITable.Data = T;

 

            x=app.bandwidth_500;
            y_500=[app.B25_500,app.B50_500,app.B75_500,app.B100_500,app.B150_500,app.B200_500,app.B300_500,app.B400_500,app.B500_500];
            app.UIAxes.XTick = app.bandwidth_500;
            app.UIAxes.XTickLabel = {'25'; '50'; '75'; '100'; '150'; '200'; '300'; '400'; '500'};
            if app.fitmodel_500==1 
            bandw_large=[min(app.bandwidth_500):1:max(app.bandwidth_500)];
            prediction=piecewisefunction(bandw_large,parameters_500,app.freq,app.frequency_500);
            semilogx(app.UIAxes,x,y_500,'ko',bandw_large,prediction,'k-',[app.Critical_Band_500  app.Critical_Band_500],[-50 180],'k--','Linewidth',2)
            th_text=['CB = ',num2str(app.Critical_Band_500,'%.2f'), ' Hz'];
            text(app.UIAxes,app.Critical_Band_500+app.Critical_Band_500*0.1,0, th_text, 'Color', 'k', 'FontSize',12)
            else            
                semilogx(app.UIAxes,x,y_500,'ko','Linewidth',2)
            end
            legend(app.UIAxes,'Data', 'Location','northwest')
            grid(app.UIAxes,'on');
            axis(app.UIAxes,[min(app.bandwidth_500)-min(app.bandwidth_500)*0.2 max(app.bandwidth_500)+max(app.bandwidth_500)*0.2 -10 60])
            hold(app.UIAxes,'off');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


parameters_2000=[app.ordenada_2000 app.Critical_Band_2000 app.exponent_2000];

            % Get Table UI component data
            t = app.UITable_2.DisplayData;            
            app.B50_2000=t.Var1;
            app.B100_2000=t.Var2;
            app.B200_2000=t.Var3;
            app.B250_2000=t.Var4;
            app.B300_2000=t.Var5;
            app.B400_2000=t.Var6;
            app.B600_2000=t.Var7;
            app.B800_2000=t.Var8;
            app.B1600_2000=t.Var9;
         % app.UITable.RowName={'Thresholds (500Hz)'};
          T=table(app.B50_2000,app.B100_2000,app.B200_2000,app.B250_2000,app.B300_2000,app.B400_2000,app.B600_2000,app.B800_2000,app.B1600_2000);
          app.UITable_2.Data = T;

            x=app.bandwidth_2000;
            y_2000=[app.B50_2000,app.B100_2000,app.B200_2000,app.B250_2000,app.B300_2000,app.B400_2000,app.B600_2000,app.B800_2000,app.B1600_2000];
            app.UIAxes_2.XTick = app.bandwidth_2000;
            app.UIAxes_2.XTickLabel = {'50'; '100'; '200'; '250'; '300'; '400'; '600'; '800'; '1600'};
            if app.fitmodel_2000==1 
            bandw_large=[min(app.bandwidth_2000):1:max(app.bandwidth_2000)];
            prediction=piecewisefunction(bandw_large,parameters_2000,app.freq,app.frequency_2000);
            semilogx(app.UIAxes_2,x,y_2000,'ko',bandw_large,prediction,'k-',[app.Critical_Band_2000  app.Critical_Band_2000],[-50 180],'k--','Linewidth',2)
            th_text=['CB = ',num2str(app.Critical_Band_2000,'%.2f'), ' Hz'];
            text(app.UIAxes_2,app.Critical_Band_2000+app.Critical_Band_2000*0.1,0, th_text, 'Color', 'k', 'FontSize',12)
            else            
                semilogx(app.UIAxes_2,x,y_2000,'ko','Linewidth',2)
            end
            legend(app.UIAxes_2,'Data', 'Location','northwest')
            grid(app.UIAxes_2,'on');
            axis(app.UIAxes_2,[min(app.bandwidth_2000)-min(app.bandwidth_2000)*0.2 max(app.bandwidth_2000)+max(app.bandwidth_2000)*0.2 -10 60])
            hold(app.UIAxes_2,'off');




function fitted_Y = piecewisefunction(bandwidth,parameters,freq,frequency)  
for j=1:length(bandwidth)
Bmin=frequency-bandwidth(j)/2;
Bmax=frequency+bandwidth(j)/2;
fun=@(freq) rectpuls(freq-frequency,parameters(2));
A(j)=integral(fun,Bmin,Bmax);
end
fitted_Y=real(parameters(1)+parameters(3)*20*log10(A));
end
        end
        

    end
    

    % Callbacks that handle component events
    methods (Access = private)

        % Code that executes after component creation
        function startupFcn(app)
            t=table(app.B25_500,app.B50_500,app.B75_500,app.B100_500,app.B150_500,app.B200_500,app.B300_500,app.B400_500,app.B500_500);     
            app.UITable.Data = t;
            t=table(app.B50_2000,app.B100_2000,app.B200_2000,app.B250_2000,app.B300_2000,app.B400_2000,app.B600_2000,app.B800_2000,app.B1600_2000);     
            app.UITable_2.Data = t;
            app.updateplot;
   
        end

        % Button pushed function: FitmodelButton_500
        function FitmodelButton_500Pushed(app, event)

Thresholds=[app.B25_500,app.B50_500,app.B75_500,app.B100_500,app.B150_500,app.B200_500,app.B300_500,app.B400_500,app.B500_500];

fmin=0;
fmax=3000;
app.freq=linspace(fmin, fmax, 1000);
CB=24.7*(1+4.37*(10^-3*app.frequency_500));%%%Critical band

opts = statset('nlinfit');
opts.MaxFunEvals=500;
opts.MaxIter=500;
opts.TolX=1E-15;
opts.TolFun=1E-15;
%%opts.Display='iter';

initialparameters=[-30 CB 2];%%%Initial parameters
band=app.bandwidth_500;

modelFun = @(initialparameters,band) piecewisefunction(band,initialparameters,app.freq,app.frequency_500);

[beta,resid,J,Sigma,mse] = nlinfit(band, Thresholds, modelFun,initialparameters,opts);
app.ordenada_500=beta(1);%%%
app.Critical_Band_500=beta(2);%%Critical Band
app.exponent_500=beta(3);

function fitted_Y = piecewisefunction(bandwidth,initialparameters,freq,frequency)  
for j=1:length(app.bandwidth_500)
Bmin=app.frequency_500-app.bandwidth_500(j)/2;
Bmax=app.frequency_500+app.bandwidth_500(j)/2;
fun=@(freq) rectpuls(freq-app.frequency_500,initialparameters(2));
A(j)=integral(fun,Bmin,Bmax);
end
fitted_Y=real(initialparameters(1)+initialparameters(3)*20*log10(A));
end

app.fitmodel_500=1;

app.updateplot;
        end

        % Button pushed function: RemovefittingButton_500
        function RemovefittingButton_500Pushed(app, event)
            app.fitmodel_500=0;
            app.updateplot;
        end

        % Button pushed function: FitmodelButton_2000
        function FitmodelButton_2000Pushed(app, event)
            Thresholds=[app.B50_2000,app.B100_2000,app.B200_2000,app.B250_2000,app.B300_2000,app.B400_2000,app.B600_2000,app.B800_2000,app.B1600_2000];

fmin=0;
fmax=3000;
app.freq=linspace(fmin, fmax, 1000);
CB=24.7*(1+4.37*(10^-3*app.frequency_2000));%%%Critical band

opts = statset('nlinfit');
opts.MaxFunEvals=500;
opts.MaxIter=500;
opts.TolX=1E-15;
opts.TolFun=1E-15;
%%opts.Display='iter';

initialparameters=[-30 CB 2];%%%Initial parameters
band=app.bandwidth_2000;

modelFun = @(initialparameters,band) piecewisefunction(band,initialparameters,app.freq,app.frequency_500);

[beta,resid,J,Sigma,mse] = nlinfit(band, Thresholds, modelFun,initialparameters,opts);
app.ordenada_2000=beta(1);%%%
app.Critical_Band_2000=beta(2);%%Critical Band
app.exponent_2000=beta(3);

function fitted_Y = piecewisefunction(bandwidth,initialparameters,freq,frequency)  
for j=1:length(app.bandwidth_2000)
Bmin=app.frequency_2000-app.bandwidth_2000(j)/2;
Bmax=app.frequency_2000+app.bandwidth_2000(j)/2;
fun=@(freq) rectpuls(freq-app.frequency_2000,initialparameters(2));
A(j)=integral(fun,Bmin,Bmax);
end
fitted_Y=real(initialparameters(1)+initialparameters(3)*20*log10(A));
end

app.fitmodel_2000=1;

app.updateplot;
        end

        % Button pushed function: RemovefittingButton_2000
        function RemovefittingButton_2000Pushed(app, event)
            app.fitmodel_2000=0;
            app.updateplot; 
        end

        % Cell selection callback: UITable
        function UITableCellSelection(app, event)
   
          app.Indices=event.Indices;
          app.updateplot;
        end

        % Display data changed function: UITable
        function UITableDisplayDataChanged(app, event)
          app.fitmodel_500=0;
          app.updateplot;
        end

        % Cell selection callback: UITable_2
        function UITable_2CellSelection(app, event)
            %%indices = event.Indices;
            app.updateplot;
        end

        % Display data changed function: UITable_2
        function UITable_2DisplayDataChanged(app, event)
            newDisplayData = app.UITable_2.DisplayData;
            app.fitmodel_2000=0;
            app.updateplot; 
        end

        % Button pushed function: ExamplesButton
        function ExamplesButtonPushed(app, event)
                    
        app.B25_500=17.5;
        app.B50_500=25.8;
        app.B75_500=35.8;
        app.B100_500=37.5;
        app.B150_500=39.2;
        app.B200_500=37.5;
        app.B300_500=35.8;
        app.B400_500=37.5;
        app.B500_500=39.2;
        app.fitmodel_500=0;


       
        app.B50_2000=5.8;
        app.B100_2000=17.5;
        app.B200_2000=30.8;
        app.B250_2000=35.8;
        app.B300_2000=35.8;
        app.B400_2000=37.5;
        app.B600_2000=37.5;
        app.B800_2000=39.2;
        app.B1600_2000=37.5;
        app.fitmodel_2000=0;

            t=table(app.B25_500,app.B50_500,app.B75_500,app.B100_500,app.B150_500,app.B200_500,app.B300_500,app.B400_500,app.B500_500);     
            app.UITable.Data = t;
            t=table(app.B50_2000,app.B100_2000,app.B200_2000,app.B250_2000,app.B300_2000,app.B400_2000,app.B600_2000,app.B800_2000,app.B1600_2000);     
            app.UITable_2.Data = t;
          app.updateplot;
        end

        % Button pushed function: ResetButton
        function ResetButtonPushed(app, event)
        
        app.B25_500=0;
        app.B50_500=0;
        app.B75_500=0;
        app.B100_500=0;
        app.B150_500=0;
        app.B200_500=0;
        app.B300_500=0;
        app.B400_500=0;
        app.B500_500=0;
        app.fitmodel_500=0;



            t=table(app.B25_500,app.B50_500,app.B75_500,app.B100_500,app.B150_500,app.B200_500,app.B300_500,app.B400_500,app.B500_500);     
            app.UITable.Data = t;
 
          app.updateplot;
        end

        % Button pushed function: ResetButton_2
        function ResetButton_2Pushed(app, event)

       
        app.B50_2000=0;
        app.B100_2000=0;
        app.B200_2000=0;
        app.B250_2000=0;
        app.B300_2000=0;
        app.B400_2000=0;
        app.B600_2000=0;
        app.B800_2000=0;
        app.B1600_2000=0;
        app.fitmodel_2000=0;

            t=table(app.B50_2000,app.B100_2000,app.B200_2000,app.B250_2000,app.B300_2000,app.B400_2000,app.B600_2000,app.B800_2000,app.B1600_2000);     
            app.UITable_2.Data = t;
          app.updateplot;
        end
    end

    % Component initialization
    methods (Access = private)

        % Create UIFigure and components
        function createComponents(app)

            % Create UIFigure and hide until all components are created
            app.UIFigure = uifigure('Visible', 'off');
            app.UIFigure.Position = [100 100 1042 557];
            app.UIFigure.Name = 'MATLAB App';
            app.UIFigure.Resize = 'off';

            % Create UIAxes
            app.UIAxes = uiaxes(app.UIFigure);
            title(app.UIAxes, 'The Critical Band (500 Hz)')
            xlabel(app.UIAxes, 'Temporal frequency (Hz)')
            ylabel(app.UIAxes, 'Signal threshold (dB SPL)')
            zlabel(app.UIAxes, 'Z')
            app.UIAxes.XTick = [];
            app.UIAxes.Position = [54 75 427 236];

            % Create UIAxes_2
            app.UIAxes_2 = uiaxes(app.UIFigure);
            title(app.UIAxes_2, 'The Critical Band (2000 Hz)')
            xlabel(app.UIAxes_2, 'Temporal frequency (Hz)')
            ylabel(app.UIAxes_2, 'Signal threshold (dB SPL)')
            zlabel(app.UIAxes_2, 'Z')
            app.UIAxes_2.XTick = [];
            app.UIAxes_2.Position = [572 75 427 236];

            % Create CriticalbandestimationLabel
            app.CriticalbandestimationLabel = uilabel(app.UIFigure);
            app.CriticalbandestimationLabel.FontSize = 14;
            app.CriticalbandestimationLabel.FontWeight = 'bold';
            app.CriticalbandestimationLabel.Position = [443 526 164 22];
            app.CriticalbandestimationLabel.Text = 'Critical band estimation';

            % Create UITable
            app.UITable = uitable(app.UIFigure);
            app.UITable.ColumnName = {'25Hz'; '50Hz'; '75Hz'; '100Hz'; '150Hz'; '200Hz'; '300Hz'; '400Hz'; '500Hz'};
            app.UITable.RowName = {'Thresholds (500Hz)'};
            app.UITable.ColumnEditable = [true true true true true true true true true];
            app.UITable.CellSelectionCallback = createCallbackFcn(app, @UITableCellSelection, true);
            app.UITable.DisplayDataChangedFcn = createCallbackFcn(app, @UITableDisplayDataChanged, true);
            app.UITable.Position = [123 452 802 55];

            % Create FitmodelButton_500
            app.FitmodelButton_500 = uibutton(app.UIFigure, 'push');
            app.FitmodelButton_500.ButtonPushedFcn = createCallbackFcn(app, @FitmodelButton_500Pushed, true);
            app.FitmodelButton_500.FontWeight = 'bold';
            app.FitmodelButton_500.Position = [109 29 100 23];
            app.FitmodelButton_500.Text = 'Fit model';

            % Create RemovefittingButton_500
            app.RemovefittingButton_500 = uibutton(app.UIFigure, 'push');
            app.RemovefittingButton_500.ButtonPushedFcn = createCallbackFcn(app, @RemovefittingButton_500Pushed, true);
            app.RemovefittingButton_500.FontWeight = 'bold';
            app.RemovefittingButton_500.Position = [242 29 100 23];
            app.RemovefittingButton_500.Text = 'Remove fitting';

            % Create UITable_2
            app.UITable_2 = uitable(app.UIFigure);
            app.UITable_2.ColumnName = {'50Hz'; '100Hz'; '200Hz'; '250Hz'; '300Hz'; '400Hz'; '600Hz'; '800Hz'; '1600Hz'};
            app.UITable_2.RowName = {'Thresholds (2000Hz)'};
            app.UITable_2.ColumnEditable = [true true true true true true true true true];
            app.UITable_2.CellSelectionCallback = createCallbackFcn(app, @UITable_2CellSelection, true);
            app.UITable_2.DisplayDataChangedFcn = createCallbackFcn(app, @UITable_2DisplayDataChanged, true);
            app.UITable_2.Position = [122 369 802 55];

            % Create FitmodelButton_2000
            app.FitmodelButton_2000 = uibutton(app.UIFigure, 'push');
            app.FitmodelButton_2000.ButtonPushedFcn = createCallbackFcn(app, @FitmodelButton_2000Pushed, true);
            app.FitmodelButton_2000.FontWeight = 'bold';
            app.FitmodelButton_2000.Position = [641 29 100 23];
            app.FitmodelButton_2000.Text = 'Fit model';

            % Create RemovefittingButton_2000
            app.RemovefittingButton_2000 = uibutton(app.UIFigure, 'push');
            app.RemovefittingButton_2000.ButtonPushedFcn = createCallbackFcn(app, @RemovefittingButton_2000Pushed, true);
            app.RemovefittingButton_2000.FontWeight = 'bold';
            app.RemovefittingButton_2000.Position = [777 29 100 23];
            app.RemovefittingButton_2000.Text = 'Remove fitting';

            % Create ExamplesButton
            app.ExamplesButton = uibutton(app.UIFigure, 'push');
            app.ExamplesButton.ButtonPushedFcn = createCallbackFcn(app, @ExamplesButtonPushed, true);
            app.ExamplesButton.Position = [935 430 100 23];
            app.ExamplesButton.Text = 'Examples';

            % Create ResetButton
            app.ResetButton = uibutton(app.UIFigure, 'push');
            app.ResetButton.ButtonPushedFcn = createCallbackFcn(app, @ResetButtonPushed, true);
            app.ResetButton.FontWeight = 'bold';
            app.ResetButton.Position = [374 29 100 23];
            app.ResetButton.Text = 'Reset';

            % Create ResetButton_2
            app.ResetButton_2 = uibutton(app.UIFigure, 'push');
            app.ResetButton_2.ButtonPushedFcn = createCallbackFcn(app, @ResetButton_2Pushed, true);
            app.ResetButton_2.FontWeight = 'bold';
            app.ResetButton_2.Position = [913 29 100 23];
            app.ResetButton_2.Text = 'Reset';

            % Create SerranoPedrazaI2023Label
            app.SerranoPedrazaI2023Label = uilabel(app.UIFigure);
            app.SerranoPedrazaI2023Label.FontSize = 9;
            app.SerranoPedrazaI2023Label.Position = [9 8 110 22];
            app.SerranoPedrazaI2023Label.Text = 'Serrano-Pedraza, I. (2023)';

            % Show the figure after all components are created
            app.UIFigure.Visible = 'on';
        end
    end

    % App creation and deletion
    methods (Access = public)

        % Construct app
        function app = Analysis_Critical_Bands

            % Create UIFigure and components
            createComponents(app)

            % Register the app with App Designer
            registerApp(app, app.UIFigure)

            % Execute the startup function
            runStartupFcn(app, @startupFcn)

            if nargout == 0
                clear app
            end
        end

        % Code that executes before app deletion
        function delete(app)

            % Delete UIFigure when app is deleted
            delete(app.UIFigure)
        end
    end
end