classdef Experiment_Audibility_curve < matlab.apps.AppBase

    % Properties that correspond to app components
    properties (Access = public)
        UIFigure                        matlab.ui.Figure
        SerranoPedrazaI2023Label        matlab.ui.control.Label
        AgeEditField                    matlab.ui.control.EditField
        AgeEditFieldLabel               matlab.ui.control.Label
        InitialsEditField               matlab.ui.control.EditField
        InitialsEditFieldLabel          matlab.ui.control.Label
        SavedataButton                  matlab.ui.control.Button
        StimuluspresentationLabel       matlab.ui.control.Label
        Switch_3                        matlab.ui.control.Switch
        Switch_2                        matlab.ui.control.Switch
        Switch_1                        matlab.ui.control.Switch
        ShowdataLabel                   matlab.ui.control.Label
        RestartButton                   matlab.ui.control.Button
        Lamp_3                          matlab.ui.control.Lamp
        Lamp_2                          matlab.ui.control.Lamp
        Lamp_1                          matlab.ui.control.Lamp
        BothEarsSwitch                  matlab.ui.control.Switch
        BothEarsSwitchLabel             matlab.ui.control.Label
        RightEarSwitch                  matlab.ui.control.Switch
        RightEarSwitchLabel             matlab.ui.control.Label
        LeftEarSwitch                   matlab.ui.control.Switch
        LeftEarSwitchLabel              matlab.ui.control.Label
        RecalibratevolumeButton         matlab.ui.control.Button
        PressthisbuttonwhenreadyButton  matlab.ui.control.Button
        VolumecalibrationLabel          matlab.ui.control.Label
        AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel  matlab.ui.control.Label
        Knob                            matlab.ui.control.Knob
        TemporalfrequencyHzLabel        matlab.ui.control.Label
        AdjustthesliderofeachpuretoneuntilyoudonthearthemLabel  matlab.ui.control.Label
        HzLabel_8                       matlab.ui.control.Label
        HzLabel_7                       matlab.ui.control.Label
        HzLabel_6                       matlab.ui.control.Label
        HzLabel_5                       matlab.ui.control.Label
        HzLabel_4                       matlab.ui.control.Label
        HzLabel_3                       matlab.ui.control.Label
        HzLabel_2                       matlab.ui.control.Label
        HzLabel_1                       matlab.ui.control.Label
        AHzSlider_8                     matlab.ui.control.Slider
        AHzSlider_7                     matlab.ui.control.Slider
        AHzSlider_6                     matlab.ui.control.Slider
        AHzSlider_5                     matlab.ui.control.Slider
        AHzSlider_4                     matlab.ui.control.Slider
        AHzSlider_3                     matlab.ui.control.Slider
        AHzSlider_2                     matlab.ui.control.Slider
        AHzSlider_1                     matlab.ui.control.Slider
        DeterminingtheMinimumAudibilitycurveLabel  matlab.ui.control.Label
        UIAxes2                         matlab.ui.control.UIAxes
        UIAxes                          matlab.ui.control.UIAxes
    end

    
    properties (Access = private)
        Slider_125_Both=100; % 
        Slider_250_Both=100; % 
        Slider_500_Both=100; % 
        Slider_1000_Both=100; % 
        Slider_2000_Both=100; % 
        Slider_4000_Both=100; % 
        Slider_8000_Both=100; % 
        Slider_12000_Both=100; % 
        
        Slider_125_Left=100; % 
        Slider_250_Left=100; % 
        Slider_500_Left=100; % 
        Slider_1000_Left=100; % 
        Slider_2000_Left=100; % 
        Slider_4000_Left=100; % 
        Slider_8000_Left=100; % 
        Slider_12000_Left=100; % 

        Slider_125_Right=100; % 
        Slider_250_Right=100; % 
        Slider_500_Right=100; % 
        Slider_1000_Right=100; % 
        Slider_2000_Right=100; % 
        Slider_4000_Right=100; % 
        Slider_8000_Right=100; % 
        Slider_12000_Right=100; % 


    end
    
    properties (Access = public)
        filename; % Description
    end

    methods (Access = private)


        function updateplot(app)

            %%Dr. Ignacio Serrano-Pedraza 2023
            %%%With this program you can obtain the audibility curve
            %%%and the audiogram using the method of adjustment.
           

            
            if isequaln(app.Switch_3.Value,'On')==1 && isequaln(app.Switch_2.Value,'Off')==1 && isequaln(app.Switch_1.Value,'Off')==1
            
            x=[125 250 500 1000 2000 4000 8000 12000];
            y=[app.Slider_125_Both app.Slider_250_Both app.Slider_500_Both app.Slider_1000_Both...
            app.Slider_2000_Both app.Slider_4000_Both app.Slider_8000_Both app.Slider_12000_Both]-app.Knob.Value;
            semilogx(app.UIAxes,x,y,'ko-','Linewidth',2)
            legend(app.UIAxes,'Both Ears', 'Location','northwest')
            grid(app.UIAxes,'on');
            axis(app.UIAxes,[100 15000 -10 80])
            hold(app.UIAxes,'off');
            standardthreshold=[21.4 11.2 6 4.2 1 -3.9 15.3 12];%%%Thresholds from ISO 1961. Robinson and Dadson (1956)
            y2=y-standardthreshold;

            semilogx(app.UIAxes2,[100:100:15000],0*[100:100:15000],'k--','Linewidth',2)
            grid(app.UIAxes2,'on');
            hold(app.UIAxes2,'on');
            ax=semilogx(app.UIAxes2,x,y2,'ko-','Linewidth',2);
            legend(ax,'Both Ears','Location','northwest')
            set(app.UIAxes2, 'ydir','reverse')
            axis(app.UIAxes2,[100 15000 -30 80])
            hold(app.UIAxes2,'off');
            end
            if isequaln(app.Switch_2.Value,'On')==1 && isequaln(app.Switch_3.Value,'Off')==1 && isequaln(app.Switch_1.Value,'Off')==1
            
            x=[125 250 500 1000 2000 4000 8000 12000];
            y_right=[app.Slider_125_Right app.Slider_250_Right app.Slider_500_Right app.Slider_1000_Right...
            app.Slider_2000_Right app.Slider_4000_Right app.Slider_8000_Right app.Slider_12000_Right]-app.Knob.Value;
            semilogx(app.UIAxes,x,y_right,'ro-','Linewidth',2)
            legend(app.UIAxes,'Right Ear',  'Location','northwest')
            grid(app.UIAxes,'on');
            axis(app.UIAxes,[100 15000 -10 80])
            hold(app.UIAxes,'off');
            standardthreshold=[21.4 11.2 6 4.2 1 -3.9 15.3 12];%%%Thresholds from ISO 1961. Robinson and Dadson (1956)
            y2_right=y_right-standardthreshold;

            semilogx(app.UIAxes2,[100:100:15000],0*[100:100:15000],'k--','Linewidth',2)
            legend(app.UIAxes2,'off')
            grid(app.UIAxes2,'on');
            hold(app.UIAxes2,'on');
            ax=semilogx(app.UIAxes2,x,y2_right,'ro-','Linewidth',2);
            legend(ax,'Right Ear','Location','northwest')
            set(app.UIAxes2, 'ydir','reverse')
            axis(app.UIAxes2,[100 15000 -30 80])
            hold(app.UIAxes2,'off');
            end

            if isequaln(app.Switch_1.Value,'On')==1 && isequaln(app.Switch_2.Value,'Off')==1 && isequaln(app.Switch_3.Value,'Off')==1
            x=[125 250 500 1000 2000 4000 8000 12000];
            y_left=[app.Slider_125_Left app.Slider_250_Left app.Slider_500_Left app.Slider_1000_Left...
            app.Slider_2000_Left app.Slider_4000_Left app.Slider_8000_Left app.Slider_12000_Left]-app.Knob.Value;
            semilogx(app.UIAxes,x,y_left,'cx-','Linewidth',2)
            legend(app.UIAxes,'Left Ear',  'Location','northwest')

            grid(app.UIAxes,'on');
            axis(app.UIAxes,[100 15000 -10 80])
            hold(app.UIAxes,'off');
            standardthreshold=[21.4 11.2 6 4.2 1 -3.9 15.3 12];%%%Thresholds from ISO 1961. Robinson and Dadson (1956)
            y2_left=y_left-standardthreshold;

            semilogx(app.UIAxes2,[100:100:15000],0*[100:100:15000],'k--','Linewidth',2)
            grid(app.UIAxes2,'on');
            hold(app.UIAxes2,'on');
            ax=semilogx(app.UIAxes2,x,y2_left,'cx-','Linewidth',2);
            legend(ax,'Left Ear',  'Location','northwest')
            set(app.UIAxes2, 'ydir','reverse')
            axis(app.UIAxes2,[100 15000 -30 80])
            hold(app.UIAxes2,'off');
            end

           if isequaln(app.Switch_2.Value,'Off')==1 && isequaln(app.Switch_3.Value,'Off')==1 && isequaln(app.Switch_1.Value,'Off')==1
            
            x=10000*[125 250 500 1000 2000 4000 8000 12000];
            y_right=[app.Slider_125_Right app.Slider_250_Right app.Slider_500_Right app.Slider_1000_Right...
            app.Slider_2000_Right app.Slider_4000_Right app.Slider_8000_Right app.Slider_12000_Right]-app.Knob.Value;
            semilogx(app.UIAxes,x,y_right,'k-','Linewidth',2)
            legend(app.UIAxes,'off')
            grid(app.UIAxes,'on');
            axis(app.UIAxes,[100 15000 -10 80])
            hold(app.UIAxes,'off');
            standardthreshold=[21.4 11.2 6 4.2 1 -3.9 15.3 12];%%%Thresholds from ISO 1961. Robinson and Dadson (1956)
            y2_right=y_right-standardthreshold;

            semilogx(app.UIAxes2,[100:100:15000],0*[100:100:15000],'k--','Linewidth',2)
            grid(app.UIAxes2,'on');
            hold(app.UIAxes2,'on');
            semilogx(app.UIAxes2,x,y2_right,'ro-','Linewidth',2)
            legend(app.UIAxes2,'off')
            set(app.UIAxes2, 'ydir','reverse')
            axis(app.UIAxes2,[100 15000 -30 80])
            hold(app.UIAxes2,'off');
            end
              
            if isequaln(app.Switch_2.Value,'On')==1 && isequaln(app.Switch_3.Value,'On')==1 && isequaln(app.Switch_1.Value,'Off')==1
            
            x=[125 250 500 1000 2000 4000 8000 12000];
            y_right=[app.Slider_125_Right app.Slider_250_Right app.Slider_500_Right app.Slider_1000_Right...
            app.Slider_2000_Right app.Slider_4000_Right app.Slider_8000_Right app.Slider_12000_Right]-app.Knob.Value;
            y=[app.Slider_125_Both app.Slider_250_Both app.Slider_500_Both app.Slider_1000_Both...
            app.Slider_2000_Both app.Slider_4000_Both app.Slider_8000_Both app.Slider_12000_Both]-app.Knob.Value;
            semilogx(app.UIAxes,x,y,'ko-',x,y_right,'ro-','Linewidth',2)
            legend(app.UIAxes,'Both Ears','Right Ear','Location','northwest')

            grid(app.UIAxes,'on');
            axis(app.UIAxes,[100 15000 -10 80])
            hold(app.UIAxes,'off');
            standardthreshold=[21.4 11.2 6 4.2 1 -3.9 15.3 12];%%%Thresholds from ISO 1961. Robinson and Dadson (1956)
            y2=y-standardthreshold;
            y2_right=y_right-standardthreshold;

            semilogx(app.UIAxes2,[100:100:15000],0*[100:100:15000],'k--','Linewidth',2)
            grid(app.UIAxes2,'on');
            hold(app.UIAxes2,'on');
            ax=semilogx(app.UIAxes2,x,y2,'ko-',x,y2_right,'ro-','Linewidth',2);
            legend(ax,'Both Ears','Right Ear','Location','northwest')
            set(app.UIAxes2, 'ydir','reverse')
            axis(app.UIAxes2,[100 15000 -30 80])
            hold(app.UIAxes2,'off');
            end

            if isequaln(app.Switch_1.Value,'On')==1 && isequaln(app.Switch_3.Value,'On')==1 && isequaln(app.Switch_2.Value,'Off')==1
            
            x=[125 250 500 1000 2000 4000 8000 12000];
            y_left=[app.Slider_125_Left app.Slider_250_Left app.Slider_500_Left app.Slider_1000_Left...
            app.Slider_2000_Left app.Slider_4000_Left app.Slider_8000_Left app.Slider_12000_Left]-app.Knob.Value;
            y=[app.Slider_125_Both app.Slider_250_Both app.Slider_500_Both app.Slider_1000_Both...
            app.Slider_2000_Both app.Slider_4000_Both app.Slider_8000_Both app.Slider_12000_Both]-app.Knob.Value;
            semilogx(app.UIAxes,x,y,'ko-',x,y_left,'cx-','Linewidth',2)
            legend(app.UIAxes,'Both Ears','Left Ear','Location','northwest')

            grid(app.UIAxes,'on');
            axis(app.UIAxes,[100 15000 -10 80])
            hold(app.UIAxes,'off');
            standardthreshold=[21.4 11.2 6 4.2 1 -3.9 15.3 12];%%%Thresholds from ISO 1961. Robinson and Dadson (1956)
            y2=y-standardthreshold;
            y2_left=y_left-standardthreshold;

            semilogx(app.UIAxes2,[100:100:15000],0*[100:100:15000],'k--','Linewidth',2)
            grid(app.UIAxes2,'on');
            hold(app.UIAxes2,'on');
            ax=semilogx(app.UIAxes2,x,y2,'ko-',x,y2_left,'cx-','Linewidth',2);
            legend(ax,'Both Ears','Left Ear','Location','northwest')
            set(app.UIAxes2, 'ydir','reverse')
            axis(app.UIAxes2,[100 15000 -30 80])
            hold(app.UIAxes2,'off');
            end
            if isequaln(app.Switch_1.Value,'On')==1 && isequaln(app.Switch_2.Value,'On')==1 && isequaln(app.Switch_3.Value,'Off')==1
            
            x=[125 250 500 1000 2000 4000 8000 12000];
            y_left=[app.Slider_125_Left app.Slider_250_Left app.Slider_500_Left app.Slider_1000_Left...
            app.Slider_2000_Left app.Slider_4000_Left app.Slider_8000_Left app.Slider_12000_Left]-app.Knob.Value;
            y_right=[app.Slider_125_Right app.Slider_250_Right app.Slider_500_Right app.Slider_1000_Right...
            app.Slider_2000_Right app.Slider_4000_Right app.Slider_8000_Right app.Slider_12000_Right]-app.Knob.Value;
            semilogx(app.UIAxes,x,y_right,'ro-',x,y_left,'cx-','Linewidth',2)
            legend(app.UIAxes,'Right Ear','Left Ear','Location','northwest')

            grid(app.UIAxes,'on');
            axis(app.UIAxes,[100 15000 -10 80])
            hold(app.UIAxes,'off');
            standardthreshold=[21.4 11.2 6 4.2 1 -3.9 15.3 12];%%%Thresholds from ISO 1961. Robinson and Dadson (1956)
            y2_left=y_left-standardthreshold;
            y2_right=y_right-standardthreshold;

            semilogx(app.UIAxes2,[100:100:15000],0*[100:100:15000],'k--','Linewidth',2)
            grid(app.UIAxes2,'on');
            hold(app.UIAxes2,'on');
            ax=semilogx(app.UIAxes2,x,y2_right,'ro-',x,y2_left,'cx-','Linewidth',2);
            legend(ax,'Right Ear','Left Ear','Location','northwest')
            set(app.UIAxes2, 'ydir','reverse')
            axis(app.UIAxes2,[100 15000 -30 80])
            hold(app.UIAxes2,'off');
            end

            if isequaln(app.Switch_1.Value,'On')==1 && isequaln(app.Switch_2.Value,'On')==1 && isequaln(app.Switch_3.Value,'On')==1
            
            x=[125 250 500 1000 2000 4000 8000 12000];
            y=[app.Slider_125_Both app.Slider_250_Both app.Slider_500_Both app.Slider_1000_Both...
            app.Slider_2000_Both app.Slider_4000_Both app.Slider_8000_Both app.Slider_12000_Both]-app.Knob.Value;
            y_left=[app.Slider_125_Left app.Slider_250_Left app.Slider_500_Left app.Slider_1000_Left...
            app.Slider_2000_Left app.Slider_4000_Left app.Slider_8000_Left app.Slider_12000_Left]-app.Knob.Value;
            y_right=[app.Slider_125_Right app.Slider_250_Right app.Slider_500_Right app.Slider_1000_Right...
            app.Slider_2000_Right app.Slider_4000_Right app.Slider_8000_Right app.Slider_12000_Right]-app.Knob.Value;
            semilogx(app.UIAxes,x,y,'ko-',x,y_right,'ro-',x,y_left,'cx-','Linewidth',2)
            legend(app.UIAxes,'Both Ears','Right Ear','Left Ear','Location','northwest')

            grid(app.UIAxes,'on');
            axis(app.UIAxes,[100 15000 -10 80])
            hold(app.UIAxes,'off');
            standardthreshold=[21.4 11.2 6 4.2 1 -3.9 15.3 12];%%%Thresholds from ISO 1961. Robinson and Dadson (1956)
            y2=y-standardthreshold;
            y2_left=y_left-standardthreshold;
            y2_right=y_right-standardthreshold;

            semilogx(app.UIAxes2,[100:100:15000],0*[100:100:15000],'k--','Linewidth',2)
            grid(app.UIAxes2,'on');
            hold(app.UIAxes2,'on');
            ax=semilogx(app.UIAxes2,x,y2,'ko-',x,y2_right,'ro-',x,y2_left,'cx-','Linewidth',2);
            legend(ax,'Both Ears','Right Ear','Left Ear','Location','northwest')
            set(app.UIAxes2, 'ydir','reverse')
            axis(app.UIAxes2,[100 15000 -30 80])
            hold(app.UIAxes2,'off');
            end

            end
        
    end


    % Callbacks that handle component events
    methods (Access = private)

        % Value changed function: AHzSlider_1
        function AHzSlider_1ValueChanged(app, event)

            volumen_dB = app.AHzSlider_1.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*125*t);
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                            app.Slider_125_Left=app.AHzSlider_1.Value;

            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                            app.Slider_125_Right=app.AHzSlider_1.Value;

            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_125_Both=app.AHzSlider_1.Value;
           
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_2
        function AHzSlider_2ValueChanged(app, event)
            volumen_dB = app.AHzSlider_2.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*250*t);
            if isequaln(app.LeftEarSwitch.Value,'On')==1
            app.Slider_250_Left=app.AHzSlider_2.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
            app.Slider_250_Right=app.AHzSlider_2.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
                app.Slider_250_Both=app.AHzSlider_2.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_3
        function AHzSlider_3ValueChanged(app, event)
            volumen_dB = app.AHzSlider_3.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*500*t);
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_500_Left=app.AHzSlider_3.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_500_Right=app.AHzSlider_3.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
                app.Slider_500_Both=app.AHzSlider_3.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_4
        function AHzSlider_4ValueChanged(app, event)
            volumen_dB = app.AHzSlider_4.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*1000*t);
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                 app.Slider_1000_Left=app.AHzSlider_4.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                 app.Slider_1000_Right=app.AHzSlider_4.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
                app.Slider_1000_Both=app.AHzSlider_4.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_5
        function AHzSlider_5ValueChanged(app, event)
            volumen_dB = app.AHzSlider_5.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*2000*t);
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_2000_Left=app.AHzSlider_5.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_2000_Right=app.AHzSlider_5.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_2000_Both=app.AHzSlider_5.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_6
        function AHzSlider_6ValueChanged(app, event)
            volumen_dB = app.AHzSlider_6.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*4000*t);
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_4000_Left=app.AHzSlider_6.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_4000_Right=app.AHzSlider_6.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_4000_Both=app.AHzSlider_6.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_7
        function AHzSlider_7ValueChanged(app, event)
            volumen_dB = app.AHzSlider_7.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*8000*t);
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_8000_Left=app.AHzSlider_7.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_8000_Right=app.AHzSlider_7.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_8000_Both=app.AHzSlider_7.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_8
        function AHzSlider_8ValueChanged(app, event)
            volumen_dB = app.AHzSlider_8.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*12000*t);
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_12000_Left=app.AHzSlider_8.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_12000_Right=app.AHzSlider_8.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_12000_Both=app.AHzSlider_8.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: Knob
        function KnobValueChanged(app, event)
            volumen_dB =  app.Knob.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*2000*t);
            R2=Amplitude*cos(2*pi*2000*t-pi);

            if isequaln(app.LeftEarSwitch.Value,'On')==1
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            %app.updateplot
        end

        % Button pushed function: PressthisbuttonwhenreadyButton
        function PressthisbuttonwhenreadyButtonPushed(app, event)
            app.RecalibratevolumeButton.Enable='on';
            app.RestartButton.Enable='on';
            app.SavedataButton.Enable='on';
            app.AgeEditField.Enable='on';
            app.AgeEditFieldLabel.Enable='on';
            app.InitialsEditField.Enable='on';
            app.InitialsEditFieldLabel.Enable='on';

            app.Knob.Enable= 'off';
            app.PressthisbuttonwhenreadyButton.Enable='off';
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.Enable='off';
            app.VolumecalibrationLabel.Enable='off';
            app.AHzSlider_1.Enable = 'on';
            app.AHzSlider_2.Enable = 'on';
            app.AHzSlider_3.Enable = 'on';
            app.AHzSlider_4.Enable = 'on';
            app.AHzSlider_5.Enable = 'on';
            app.AHzSlider_6.Enable = 'on';
            app.AHzSlider_7.Enable = 'on';
            app.AHzSlider_8.Enable = 'on';
            app.UIAxes.Visible='on';
            app.UIAxes2.Visible='on';
            app.TemporalfrequencyHzLabel.Enable= 'on';
            app.AdjustthesliderofeachpuretoneuntilyoudonthearthemLabel.Enable= 'on';

            app.HzLabel_1.Enable = 'on';
            app.HzLabel_2.Enable = 'on';
            app.HzLabel_3.Enable = 'on';
            app.HzLabel_4.Enable = 'on';
            app.HzLabel_5.Enable = 'on';
            app.HzLabel_6.Enable = 'on';
            app.HzLabel_7.Enable = 'on';
            app.HzLabel_8.Enable = 'on';

            app.RightEarSwitch.Enable= 'On';
            app.LeftEarSwitch.Enable= 'On';
            app.BothEarsSwitch.Enable= 'On';
            app.Lamp_1.Enable= 'On';
            app.Lamp_2.Enable= 'On';
            app.Lamp_3.Enable= 'On';
            app.LeftEarSwitch.Value= 'Off';
            app.RightEarSwitch.Value= 'Off';
            app.Switch_1.Enable = 'On';
            app.Switch_2.Enable = 'On';
            app.Switch_3.Enable = 'On';

            app.updateplot;
        end

        % Button pushed function: RecalibratevolumeButton
        function RecalibratevolumeButtonPushed(app, event)
            app.RecalibratevolumeButton.Enable='off';
            app.RestartButton.Enable='off';
            app.SavedataButton.Enable='off';
            app.AgeEditField.Enable='off';
            app.AgeEditFieldLabel.Enable='off';
            app.InitialsEditField.Enable='off';
            app.InitialsEditFieldLabel.Enable='off';

            app.Knob.Enable= 'on';
            app.PressthisbuttonwhenreadyButton.Enable='on';
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.Enable='on';
            app.VolumecalibrationLabel.Enable='on';
            app.AHzSlider_1.Enable = 'off';
            app.AHzSlider_2.Enable = 'off';
            app.AHzSlider_3.Enable = 'off';
            app.AHzSlider_4.Enable = 'off';
            app.AHzSlider_5.Enable = 'off';
            app.AHzSlider_6.Enable = 'off';
            app.AHzSlider_7.Enable = 'off';
            app.AHzSlider_8.Enable = 'off';
            app.UIAxes.Visible='on';
            app.UIAxes2.Visible='on';
            app.TemporalfrequencyHzLabel.Enable= 'off';
            app.AdjustthesliderofeachpuretoneuntilyoudonthearthemLabel.Enable= 'off';

            app.HzLabel_1.Enable = 'off';
            app.HzLabel_2.Enable = 'off';
            app.HzLabel_3.Enable = 'off';
            app.HzLabel_4.Enable = 'off';
            app.HzLabel_5.Enable = 'off';
            app.HzLabel_6.Enable = 'off';
            app.HzLabel_7.Enable = 'off';
            app.HzLabel_8.Enable = 'off';

            app.RightEarSwitch.Enable= 'Off';
            app.LeftEarSwitch.Enable= 'Off';
            app.BothEarsSwitch.Enable= 'Off';
            app.BothEarsSwitch.Value= 'On';
            app.Lamp_1.Enable= 'Off';
            app.Lamp_2.Enable= 'Off';
            app.Lamp_3.Enable= 'Off';
            app.Lamp_1.Color = [0 1 0];
            app.Lamp_2.Color = [1 0 0];
            app.Lamp_3.Color = [1 0 0];

            app.Switch_1.Enable = 'Off';
            app.Switch_2.Enable = 'Off';
            app.Switch_3.Enable = 'Off';
        end

        % Value changed function: BothEarsSwitch
        function BothEarsSwitchValueChanged(app, event)
            value = app.BothEarsSwitch.Value;
            app.LeftEarSwitch.Value= 'Off';
            app.RightEarSwitch.Value= 'Off';
            app.BothEarsSwitch.Value= 'On';
            app.Lamp_1.Color = [0 1 0];
            app.Lamp_2.Color = [1 0 0];
            app.Lamp_3.Color = [1 0 0];
            app.AHzSlider_1.Value=app.Slider_125_Both;
            app.AHzSlider_2.Value=app.Slider_250_Both;
            app.AHzSlider_3.Value=app.Slider_500_Both;
            app.AHzSlider_4.Value=app.Slider_1000_Both;
            app.AHzSlider_5.Value=app.Slider_2000_Both;
            app.AHzSlider_6.Value=app.Slider_4000_Both;
            app.AHzSlider_7.Value=app.Slider_8000_Both;
            app.AHzSlider_8.Value=app.Slider_12000_Both;
            app.Switch_3.Value = 'On';
            app.updateplot;
        end

        % Value changed function: LeftEarSwitch
        function LeftEarSwitchValueChanged(app, event)
            value = app.LeftEarSwitch.Value;
            app.BothEarsSwitch.Value= 'Off';
            app.RightEarSwitch.Value= 'Off';
            app.LeftEarSwitch.Value= 'On';
            app.Lamp_1.Color = [1 0 0];
            app.Lamp_2.Color = [1 0 0];
            app.Lamp_3.Color = [0 1 0]; 
            app.AHzSlider_1.Value=app.Slider_125_Left;
            app.AHzSlider_2.Value=app.Slider_250_Left;
            app.AHzSlider_3.Value=app.Slider_500_Left;
            app.AHzSlider_4.Value=app.Slider_1000_Left;
            app.AHzSlider_5.Value=app.Slider_2000_Left;
            app.AHzSlider_6.Value=app.Slider_4000_Left;
            app.AHzSlider_7.Value=app.Slider_8000_Left;
            app.AHzSlider_8.Value=app.Slider_12000_Left;
            app.Switch_1.Value = 'On';
            app.updateplot;
        end

        % Value changed function: RightEarSwitch
        function RightEarSwitchValueChanged(app, event)
            value = app.RightEarSwitch.Value;
            app.LeftEarSwitch.Value= 'Off';
            app.BothEarsSwitch.Value= 'Off';
            app.RightEarSwitch.Value= 'On';
            app.Lamp_1.Color = [1 0 0];
            app.Lamp_2.Color = [0 1 0];
            app.Lamp_3.Color = [1 0 0]; 
            app.AHzSlider_1.Value=app.Slider_125_Right;
            app.AHzSlider_2.Value=app.Slider_250_Right;
            app.AHzSlider_3.Value=app.Slider_500_Right;
            app.AHzSlider_4.Value=app.Slider_1000_Right;
            app.AHzSlider_5.Value=app.Slider_2000_Right;
            app.AHzSlider_6.Value=app.Slider_4000_Right;
            app.AHzSlider_7.Value=app.Slider_8000_Right;
            app.AHzSlider_8.Value=app.Slider_12000_Right;
            app.Switch_2.Value = 'On';
            app.updateplot;
        end

        % Button pushed function: RestartButton
        function RestartButtonPushed(app, event)
            app.RecalibratevolumeButton.Enable='off';
            app.RestartButton.Enable='off';
            app.SavedataButton.Enable='off';
            app.AgeEditField.Enable='off';
            app.AgeEditFieldLabel.Enable='off';
            app.InitialsEditField.Enable='off';
            app.InitialsEditFieldLabel.Enable='off';
            app.AgeEditField.Value='';
            app.InitialsEditField.Value='';
            app.Knob.Enable= 'on';
            app.PressthisbuttonwhenreadyButton.Enable='on';
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.Enable='on';
            app.VolumecalibrationLabel.Enable='on';
            app.AHzSlider_1.Enable = 'off';
            app.AHzSlider_2.Enable = 'off';
            app.AHzSlider_3.Enable = 'off';
            app.AHzSlider_4.Enable = 'off';
            app.AHzSlider_5.Enable = 'off';
            app.AHzSlider_6.Enable = 'off';
            app.AHzSlider_7.Enable = 'off';
            app.AHzSlider_8.Enable = 'off';
            
            app.TemporalfrequencyHzLabel.Enable= 'off';
            app.AdjustthesliderofeachpuretoneuntilyoudonthearthemLabel.Enable= 'off';

            app.HzLabel_1.Enable = 'off';
            app.HzLabel_2.Enable = 'off';
            app.HzLabel_3.Enable = 'off';
            app.HzLabel_4.Enable = 'off';
            app.HzLabel_5.Enable = 'off';
            app.HzLabel_6.Enable = 'off';
            app.HzLabel_7.Enable = 'off';
            app.HzLabel_8.Enable = 'off';

            app.RightEarSwitch.Enable= 'Off';
            app.LeftEarSwitch.Enable= 'Off';
            app.BothEarsSwitch.Enable= 'Off';
            app.BothEarsSwitch.Value= 'On';
            app.Lamp_1.Enable= 'On';
            app.Lamp_2.Enable= 'Off';
            app.Lamp_3.Enable= 'Off';
            app.Lamp_1.Color = [0 1 0];
            app.Lamp_2.Color = [1 0 0];
            app.Lamp_3.Color = [1 0 0];
            
            app.AHzSlider_1.Value=100;
            app.AHzSlider_2.Value=100;
            app.AHzSlider_3.Value=100;
            app.AHzSlider_4.Value=100;
            app.AHzSlider_5.Value=100;
            app.AHzSlider_6.Value=100;
            app.AHzSlider_7.Value=100;
            app.AHzSlider_8.Value=100;

            app.Slider_125_Both=100;
            app.Slider_250_Both=100;
            app.Slider_500_Both=100;
            app.Slider_1000_Both=100;
            app.Slider_2000_Both=100;
            app.Slider_4000_Both=100;
            app.Slider_8000_Both=100;
            app.Slider_12000_Both=100;

            app.Slider_125_Left=100;
            app.Slider_250_Left=100;
            app.Slider_500_Left=100;
            app.Slider_1000_Left=100;
            app.Slider_2000_Left=100;
            app.Slider_4000_Left=100;
            app.Slider_8000_Left=100;
            app.Slider_12000_Left=100;

            app.Slider_125_Right=100;
            app.Slider_250_Right=100;
            app.Slider_500_Right=100;
            app.Slider_1000_Right=100;
            app.Slider_2000_Right=100;
            app.Slider_4000_Right=100;
            app.Slider_8000_Right=100;
            app.Slider_12000_Right=100;

            app.Switch_1.Enable = 'Off';
            app.Switch_2.Enable = 'Off';
            app.Switch_3.Enable = 'Off';
            app.Switch_1.Value = 'Off';
            app.Switch_2.Value= 'Off';
            app.Switch_3.Value = 'On';
            app.updateplot;
        end

        % Value changed function: Switch_1
        function Switch_1ValueChanged(app, event)

            app.updateplot;
        end

        % Value changed function: Switch_2
        function Switch_2ValueChanged(app, event)
            app.updateplot;
        end

        % Value changed function: Switch_3
        function Switch_3ValueChanged(app, event)
           app.updateplot;
            
        end

        % Button pushed function: SavedataButton
        function SavedataButtonPushed(app, event)
                Age= string(app.AgeEditField.Value);
                Initials= string(app.InitialsEditField.Value);
                expt.initials=app.InitialsEditField.Value;
                mfile_name          = mfilename('fullpath');
                [pathstr,name,ext]  = fileparts(mfile_name);
                cd(pathstr);
                app.filename = strrep(strrep(['DATA_AUDIBILITY_CURVE/Data_' expt.initials '_' datestr(now) '.xlsx'],' ','_'),':','-');
                
            Thresholds_Both_Ears=[app.Slider_125_Both app.Slider_250_Both app.Slider_500_Both app.Slider_1000_Both...
            app.Slider_2000_Both app.Slider_4000_Both app.Slider_8000_Both app.Slider_12000_Both]'-app.Knob.Value;
            Thresholds_Left_Ear=[app.Slider_125_Left app.Slider_250_Left app.Slider_500_Left app.Slider_1000_Left...
            app.Slider_2000_Left app.Slider_4000_Left app.Slider_8000_Left app.Slider_12000_Left]'-app.Knob.Value;
            Thresholds_Right_Ear=[app.Slider_125_Right app.Slider_250_Right app.Slider_500_Right app.Slider_1000_Right...
            app.Slider_2000_Right app.Slider_4000_Right app.Slider_8000_Right app.Slider_12000_Right]'-app.Knob.Value;
            
            standardthreshold=[21.4 11.2 6 4.2 1 -3.9 15.3 12]';%%%Thresholds from ISO 1961. Robinson and Dadson (1956)
            Audiogram_Both_Ears=[standardthreshold-Thresholds_Both_Ears];
            Audiogram_Left_Ear=[standardthreshold-Thresholds_Left_Ear];
            Audiogram_Right_Ear=[standardthreshold-Thresholds_Right_Ear];
            
           Temporal_Frequency=[125 250 500 1000 2000 4000 8000 12000]';


                T=table(Temporal_Frequency,Thresholds_Both_Ears,Thresholds_Left_Ear,Thresholds_Right_Ear,Audiogram_Both_Ears,Audiogram_Left_Ear,Audiogram_Right_Ear);
                writetable(T,app.filename,'Sheet',1,'Range','A1');

                T=table(Age,Initials);
                writetable(T,app.filename,'Sheet',1,'Range','H1');
        end
    end

    % Component initialization
    methods (Access = private)

        % Create UIFigure and components
        function createComponents(app)

            % Create UIFigure and hide until all components are created
            app.UIFigure = uifigure('Visible', 'off');
            app.UIFigure.AutoResizeChildren = 'off';
            app.UIFigure.Position = [100 100 1171 568];
            app.UIFigure.Name = 'MATLAB App';
            app.UIFigure.Resize = 'off';

            % Create UIAxes
            app.UIAxes = uiaxes(app.UIFigure);
            title(app.UIAxes, 'The Minimum Audibility Curve')
            xlabel(app.UIAxes, 'Temporal frequency (Hz)')
            ylabel(app.UIAxes, 'Sound Pressure Level (dB)')
            zlabel(app.UIAxes, 'Z')
            app.UIAxes.XTick = [125 250 500 1000 2000 4000 8000 12000];
            app.UIAxes.XTickLabel = {'125'; '250'; '500'; '1000'; '2000'; '4000'; '8000'; '12000'};
            app.UIAxes.Box = 'on';
            app.UIAxes.Visible = 'off';
            app.UIAxes.Position = [772 307 363 234];

            % Create UIAxes2
            app.UIAxes2 = uiaxes(app.UIFigure);
            title(app.UIAxes2, 'Audiogram')
            xlabel(app.UIAxes2, 'Temporal frequency (Hz)')
            ylabel(app.UIAxes2, 'Hearing Level (dB re ISO 1961)')
            zlabel(app.UIAxes2, 'Z')
            app.UIAxes2.XTick = [125 250 500 1000 2000 4000 8000 12000];
            app.UIAxes2.XTickLabel = {'125'; '250'; '500'; '1000'; '2000'; '4000'; '8000'; '12000'};
            app.UIAxes2.YTick = [-30 -20 -10 0 10 20 30 40 50 60 70 80];
            app.UIAxes2.YTickLabel = {'-30'; '-20'; '-10'; '0'; '10'; '20'; '30'; '40'; '50'; '60'; '70'; '80'};
            app.UIAxes2.Box = 'on';
            app.UIAxes2.Visible = 'off';
            app.UIAxes2.Position = [772 21 363 279];

            % Create DeterminingtheMinimumAudibilitycurveLabel
            app.DeterminingtheMinimumAudibilitycurveLabel = uilabel(app.UIFigure);
            app.DeterminingtheMinimumAudibilitycurveLabel.FontSize = 18;
            app.DeterminingtheMinimumAudibilitycurveLabel.FontWeight = 'bold';
            app.DeterminingtheMinimumAudibilitycurveLabel.Position = [376 533 370 24];
            app.DeterminingtheMinimumAudibilitycurveLabel.Text = 'Determining the Minimum Audibility curve';

            % Create AHzSlider_1
            app.AHzSlider_1 = uislider(app.UIFigure);
            app.AHzSlider_1.Orientation = 'vertical';
            app.AHzSlider_1.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_1ValueChanged, true);
            app.AHzSlider_1.Enable = 'off';
            app.AHzSlider_1.Position = [59 171 3 171];
            app.AHzSlider_1.Value = 100;

            % Create AHzSlider_2
            app.AHzSlider_2 = uislider(app.UIFigure);
            app.AHzSlider_2.Orientation = 'vertical';
            app.AHzSlider_2.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_2ValueChanged, true);
            app.AHzSlider_2.Enable = 'off';
            app.AHzSlider_2.Position = [143 171 3 171];
            app.AHzSlider_2.Value = 100;

            % Create AHzSlider_3
            app.AHzSlider_3 = uislider(app.UIFigure);
            app.AHzSlider_3.Orientation = 'vertical';
            app.AHzSlider_3.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_3ValueChanged, true);
            app.AHzSlider_3.Enable = 'off';
            app.AHzSlider_3.Position = [230 171 3 171];
            app.AHzSlider_3.Value = 100;

            % Create AHzSlider_4
            app.AHzSlider_4 = uislider(app.UIFigure);
            app.AHzSlider_4.Orientation = 'vertical';
            app.AHzSlider_4.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_4ValueChanged, true);
            app.AHzSlider_4.Enable = 'off';
            app.AHzSlider_4.Position = [314 171 3 171];
            app.AHzSlider_4.Value = 100;

            % Create AHzSlider_5
            app.AHzSlider_5 = uislider(app.UIFigure);
            app.AHzSlider_5.Orientation = 'vertical';
            app.AHzSlider_5.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_5ValueChanged, true);
            app.AHzSlider_5.Enable = 'off';
            app.AHzSlider_5.Position = [400 171 3 171];
            app.AHzSlider_5.Value = 100;

            % Create AHzSlider_6
            app.AHzSlider_6 = uislider(app.UIFigure);
            app.AHzSlider_6.Orientation = 'vertical';
            app.AHzSlider_6.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_6ValueChanged, true);
            app.AHzSlider_6.Enable = 'off';
            app.AHzSlider_6.Position = [481 171 3 171];
            app.AHzSlider_6.Value = 100;

            % Create AHzSlider_7
            app.AHzSlider_7 = uislider(app.UIFigure);
            app.AHzSlider_7.Orientation = 'vertical';
            app.AHzSlider_7.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_7ValueChanged, true);
            app.AHzSlider_7.Enable = 'off';
            app.AHzSlider_7.Position = [564 171 3 171];
            app.AHzSlider_7.Value = 100;

            % Create AHzSlider_8
            app.AHzSlider_8 = uislider(app.UIFigure);
            app.AHzSlider_8.Orientation = 'vertical';
            app.AHzSlider_8.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_8ValueChanged, true);
            app.AHzSlider_8.Enable = 'off';
            app.AHzSlider_8.Position = [646 171 3 171];
            app.AHzSlider_8.Value = 100;

            % Create HzLabel_1
            app.HzLabel_1 = uilabel(app.UIFigure);
            app.HzLabel_1.HorizontalAlignment = 'right';
            app.HzLabel_1.Enable = 'off';
            app.HzLabel_1.Position = [51 129 43 22];
            app.HzLabel_1.Text = '125 Hz';

            % Create HzLabel_2
            app.HzLabel_2 = uilabel(app.UIFigure);
            app.HzLabel_2.HorizontalAlignment = 'right';
            app.HzLabel_2.Enable = 'off';
            app.HzLabel_2.Position = [132 129 43 22];
            app.HzLabel_2.Text = '250 Hz';

            % Create HzLabel_3
            app.HzLabel_3 = uilabel(app.UIFigure);
            app.HzLabel_3.HorizontalAlignment = 'right';
            app.HzLabel_3.Enable = 'off';
            app.HzLabel_3.Position = [220 129 43 22];
            app.HzLabel_3.Text = '500 Hz';

            % Create HzLabel_4
            app.HzLabel_4 = uilabel(app.UIFigure);
            app.HzLabel_4.HorizontalAlignment = 'right';
            app.HzLabel_4.Enable = 'off';
            app.HzLabel_4.Position = [300 129 49 22];
            app.HzLabel_4.Text = '1000 Hz';

            % Create HzLabel_5
            app.HzLabel_5 = uilabel(app.UIFigure);
            app.HzLabel_5.HorizontalAlignment = 'right';
            app.HzLabel_5.Enable = 'off';
            app.HzLabel_5.Position = [389 129 49 22];
            app.HzLabel_5.Text = '2000 Hz';

            % Create HzLabel_6
            app.HzLabel_6 = uilabel(app.UIFigure);
            app.HzLabel_6.HorizontalAlignment = 'right';
            app.HzLabel_6.Enable = 'off';
            app.HzLabel_6.Position = [470 129 49 22];
            app.HzLabel_6.Text = '4000 Hz';

            % Create HzLabel_7
            app.HzLabel_7 = uilabel(app.UIFigure);
            app.HzLabel_7.HorizontalAlignment = 'right';
            app.HzLabel_7.Enable = 'off';
            app.HzLabel_7.Position = [555 129 49 22];
            app.HzLabel_7.Text = '8000 Hz';

            % Create HzLabel_8
            app.HzLabel_8 = uilabel(app.UIFigure);
            app.HzLabel_8.HorizontalAlignment = 'right';
            app.HzLabel_8.Enable = 'off';
            app.HzLabel_8.Position = [627 129 56 22];
            app.HzLabel_8.Text = '12000 Hz';

            % Create AdjustthesliderofeachpuretoneuntilyoudonthearthemLabel
            app.AdjustthesliderofeachpuretoneuntilyoudonthearthemLabel = uilabel(app.UIFigure);
            app.AdjustthesliderofeachpuretoneuntilyoudonthearthemLabel.Enable = 'off';
            app.AdjustthesliderofeachpuretoneuntilyoudonthearthemLabel.Position = [210 363 331 22];
            app.AdjustthesliderofeachpuretoneuntilyoudonthearthemLabel.Text = 'Adjust the slider of each pure tone until you don''t hear them';

            % Create TemporalfrequencyHzLabel
            app.TemporalfrequencyHzLabel = uilabel(app.UIFigure);
            app.TemporalfrequencyHzLabel.FontSize = 14;
            app.TemporalfrequencyHzLabel.Enable = 'off';
            app.TemporalfrequencyHzLabel.Position = [287 93 156 22];
            app.TemporalfrequencyHzLabel.Text = 'Temporal frequency (Hz)';

            % Create Knob
            app.Knob = uiknob(app.UIFigure, 'continuous');
            app.Knob.ValueChangedFcn = createCallbackFcn(app, @KnobValueChanged, true);
            app.Knob.Position = [184 444 60 60];
            app.Knob.Value = 50;

            % Create AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel = uilabel(app.UIFigure);
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.HorizontalAlignment = 'center';
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.WordWrap = 'on';
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.Position = [17 452 127 44];
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.Text = 'Adjust the volume moving the knob so the sound is barely audible';

            % Create VolumecalibrationLabel
            app.VolumecalibrationLabel = uilabel(app.UIFigure);
            app.VolumecalibrationLabel.Position = [166 532 116 27];
            app.VolumecalibrationLabel.Text = 'Volume calibration';

            % Create PressthisbuttonwhenreadyButton
            app.PressthisbuttonwhenreadyButton = uibutton(app.UIFigure, 'push');
            app.PressthisbuttonwhenreadyButton.ButtonPushedFcn = createCallbackFcn(app, @PressthisbuttonwhenreadyButtonPushed, true);
            app.PressthisbuttonwhenreadyButton.WordWrap = 'on';
            app.PressthisbuttonwhenreadyButton.Position = [297 444 80 52];
            app.PressthisbuttonwhenreadyButton.Text = 'Press this button when ready';

            % Create RecalibratevolumeButton
            app.RecalibratevolumeButton = uibutton(app.UIFigure, 'push');
            app.RecalibratevolumeButton.ButtonPushedFcn = createCallbackFcn(app, @RecalibratevolumeButtonPushed, true);
            app.RecalibratevolumeButton.Enable = 'off';
            app.RecalibratevolumeButton.Position = [25 32 118 23];
            app.RecalibratevolumeButton.Text = 'Recalibrate volume';

            % Create LeftEarSwitchLabel
            app.LeftEarSwitchLabel = uilabel(app.UIFigure);
            app.LeftEarSwitchLabel.HorizontalAlignment = 'center';
            app.LeftEarSwitchLabel.Enable = 'off';
            app.LeftEarSwitchLabel.Position = [525 478 47 22];
            app.LeftEarSwitchLabel.Text = 'Left Ear';

            % Create LeftEarSwitch
            app.LeftEarSwitch = uiswitch(app.UIFigure, 'slider');
            app.LeftEarSwitch.ValueChangedFcn = createCallbackFcn(app, @LeftEarSwitchValueChanged, true);
            app.LeftEarSwitch.Enable = 'off';
            app.LeftEarSwitch.Position = [446 479 45 20];

            % Create RightEarSwitchLabel
            app.RightEarSwitchLabel = uilabel(app.UIFigure);
            app.RightEarSwitchLabel.HorizontalAlignment = 'center';
            app.RightEarSwitchLabel.Enable = 'off';
            app.RightEarSwitchLabel.Position = [525 449 54 22];
            app.RightEarSwitchLabel.Text = 'Right Ear';

            % Create RightEarSwitch
            app.RightEarSwitch = uiswitch(app.UIFigure, 'slider');
            app.RightEarSwitch.ValueChangedFcn = createCallbackFcn(app, @RightEarSwitchValueChanged, true);
            app.RightEarSwitch.Enable = 'off';
            app.RightEarSwitch.Position = [446 450 45 20];

            % Create BothEarsSwitchLabel
            app.BothEarsSwitchLabel = uilabel(app.UIFigure);
            app.BothEarsSwitchLabel.HorizontalAlignment = 'center';
            app.BothEarsSwitchLabel.Enable = 'off';
            app.BothEarsSwitchLabel.Position = [524 421 58 22];
            app.BothEarsSwitchLabel.Text = 'Both Ears';

            % Create BothEarsSwitch
            app.BothEarsSwitch = uiswitch(app.UIFigure, 'slider');
            app.BothEarsSwitch.ValueChangedFcn = createCallbackFcn(app, @BothEarsSwitchValueChanged, true);
            app.BothEarsSwitch.Enable = 'off';
            app.BothEarsSwitch.Position = [447 422 45 20];
            app.BothEarsSwitch.Value = 'On';

            % Create Lamp_1
            app.Lamp_1 = uilamp(app.UIFigure);
            app.Lamp_1.Enable = 'off';
            app.Lamp_1.Position = [397 424 20 20];

            % Create Lamp_2
            app.Lamp_2 = uilamp(app.UIFigure);
            app.Lamp_2.Enable = 'off';
            app.Lamp_2.Position = [397 452 20 20];
            app.Lamp_2.Color = [1 0 0];

            % Create Lamp_3
            app.Lamp_3 = uilamp(app.UIFigure);
            app.Lamp_3.Enable = 'off';
            app.Lamp_3.Position = [397 479 20 20];
            app.Lamp_3.Color = [1 0 0];

            % Create RestartButton
            app.RestartButton = uibutton(app.UIFigure, 'push');
            app.RestartButton.ButtonPushedFcn = createCallbackFcn(app, @RestartButtonPushed, true);
            app.RestartButton.Enable = 'off';
            app.RestartButton.Position = [174 32 100 23];
            app.RestartButton.Text = 'Restart';

            % Create ShowdataLabel
            app.ShowdataLabel = uilabel(app.UIFigure);
            app.ShowdataLabel.FontWeight = 'bold';
            app.ShowdataLabel.Position = [650 503 77 22];
            app.ShowdataLabel.Text = 'Show data';

            % Create Switch_1
            app.Switch_1 = uiswitch(app.UIFigure, 'slider');
            app.Switch_1.ValueChangedFcn = createCallbackFcn(app, @Switch_1ValueChanged, true);
            app.Switch_1.Enable = 'off';
            app.Switch_1.Position = [660 476 45 20];

            % Create Switch_2
            app.Switch_2 = uiswitch(app.UIFigure, 'slider');
            app.Switch_2.ValueChangedFcn = createCallbackFcn(app, @Switch_2ValueChanged, true);
            app.Switch_2.Enable = 'off';
            app.Switch_2.Position = [659 450 45 20];

            % Create Switch_3
            app.Switch_3 = uiswitch(app.UIFigure, 'slider');
            app.Switch_3.ValueChangedFcn = createCallbackFcn(app, @Switch_3ValueChanged, true);
            app.Switch_3.Enable = 'off';
            app.Switch_3.Position = [659 422 45 20];
            app.Switch_3.Value = 'On';

            % Create StimuluspresentationLabel
            app.StimuluspresentationLabel = uilabel(app.UIFigure);
            app.StimuluspresentationLabel.FontWeight = 'bold';
            app.StimuluspresentationLabel.Position = [432 503 130 22];
            app.StimuluspresentationLabel.Text = 'Stimulus presentation';

            % Create SavedataButton
            app.SavedataButton = uibutton(app.UIFigure, 'push');
            app.SavedataButton.ButtonPushedFcn = createCallbackFcn(app, @SavedataButtonPushed, true);
            app.SavedataButton.FontWeight = 'bold';
            app.SavedataButton.Enable = 'off';
            app.SavedataButton.Position = [660 54 100 23];
            app.SavedataButton.Text = 'Save data';

            % Create InitialsEditFieldLabel
            app.InitialsEditFieldLabel = uilabel(app.UIFigure);
            app.InitialsEditFieldLabel.HorizontalAlignment = 'right';
            app.InitialsEditFieldLabel.Enable = 'off';
            app.InitialsEditFieldLabel.Position = [520 71 39 22];
            app.InitialsEditFieldLabel.Text = 'Initials';

            % Create InitialsEditField
            app.InitialsEditField = uieditfield(app.UIFigure, 'text');
            app.InitialsEditField.Enable = 'off';
            app.InitialsEditField.Position = [574 71 75 22];

            % Create AgeEditFieldLabel
            app.AgeEditFieldLabel = uilabel(app.UIFigure);
            app.AgeEditFieldLabel.HorizontalAlignment = 'right';
            app.AgeEditFieldLabel.Enable = 'off';
            app.AgeEditFieldLabel.Position = [530 37 26 22];
            app.AgeEditFieldLabel.Text = 'Age';

            % Create AgeEditField
            app.AgeEditField = uieditfield(app.UIFigure, 'text');
            app.AgeEditField.CharacterLimits = [0 150];
            app.AgeEditField.InputType = 'digits';
            app.AgeEditField.Enable = 'off';
            app.AgeEditField.Position = [575 37 74 22];

            % Create SerranoPedrazaI2023Label
            app.SerranoPedrazaI2023Label = uilabel(app.UIFigure);
            app.SerranoPedrazaI2023Label.FontSize = 9;
            app.SerranoPedrazaI2023Label.Position = [6 1 110 22];
            app.SerranoPedrazaI2023Label.Text = 'Serrano-Pedraza, I. (2023)';

            % Show the figure after all components are created
            app.UIFigure.Visible = 'on';
        end
    end

    % App creation and deletion
    methods (Access = public)

        % Construct app
        function app = Experiment_Audibility_curve

            % Create UIFigure and components
            createComponents(app)

            % Register the app with App Designer
            registerApp(app, app.UIFigure)

            if nargout == 0
                clear app
            end
        end

        % Code that executes before app deletion
        function delete(app)

            % Delete UIFigure when app is deleted
            delete(app.UIFigure)
        end
    end
end