classdef Experiment_Critical_Bands < matlab.apps.AppBase

    % Properties that correspond to app components
    properties (Access = public)
        UIFigure                        matlab.ui.Figure
        RemovefittingButton             matlab.ui.control.Button
        FitthemodelwhentheexperimentisfinishedLabel  matlab.ui.control.Label
        FitmodelButton                  matlab.ui.control.Button
        HzLabel_9                       matlab.ui.control.Label
        AHzSlider_9                     matlab.ui.control.Slider
        TemporalFrequencyofthesignalButtonGroup  matlab.ui.container.ButtonGroup
        HzButton_2000                   matlab.ui.control.RadioButton
        HzButton_500                    matlab.ui.control.RadioButton
        SerranoPedrazaI2023Label        matlab.ui.control.Label
        AgeEditField                    matlab.ui.control.EditField
        AgeEditFieldLabel               matlab.ui.control.Label
        InitialsEditField               matlab.ui.control.EditField
        InitialsEditFieldLabel          matlab.ui.control.Label
        SavedataButton                  matlab.ui.control.Button
        StimuluspresentationLabel       matlab.ui.control.Label
        Switch_3                        matlab.ui.control.Switch
        Switch_2                        matlab.ui.control.Switch
        Switch_1                        matlab.ui.control.Switch
        ShowdataLabel                   matlab.ui.control.Label
        RestartButton                   matlab.ui.control.Button
        Lamp_3                          matlab.ui.control.Lamp
        Lamp_2                          matlab.ui.control.Lamp
        Lamp_1                          matlab.ui.control.Lamp
        BothEarsSwitch                  matlab.ui.control.Switch
        BothEarsSwitchLabel             matlab.ui.control.Label
        RightEarSwitch                  matlab.ui.control.Switch
        RightEarSwitchLabel             matlab.ui.control.Label
        LeftEarSwitch                   matlab.ui.control.Switch
        LeftEarSwitchLabel              matlab.ui.control.Label
        RecalibratevolumeButton         matlab.ui.control.Button
        PressthisbuttonwhenreadyButton  matlab.ui.control.Button
        VolumecalibrationLabel          matlab.ui.control.Label
        AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel  matlab.ui.control.Label
        Knob                            matlab.ui.control.Knob
        BandwidthofthebandpassnoiseLabel  matlab.ui.control.Label
        AdjusttheslideruntilyoudonthearthesignalinsertedinnoiseLabel  matlab.ui.control.Label
        HzLabel_8                       matlab.ui.control.Label
        HzLabel_7                       matlab.ui.control.Label
        HzLabel_6                       matlab.ui.control.Label
        HzLabel_5                       matlab.ui.control.Label
        HzLabel_4                       matlab.ui.control.Label
        HzLabel_3                       matlab.ui.control.Label
        HzLabel_2                       matlab.ui.control.Label
        HzLabel_1                       matlab.ui.control.Label
        AHzSlider_8                     matlab.ui.control.Slider
        AHzSlider_7                     matlab.ui.control.Slider
        AHzSlider_6                     matlab.ui.control.Slider
        AHzSlider_5                     matlab.ui.control.Slider
        AHzSlider_4                     matlab.ui.control.Slider
        AHzSlider_3                     matlab.ui.control.Slider
        AHzSlider_2                     matlab.ui.control.Slider
        AHzSlider_1                     matlab.ui.control.Slider
        EstimationofthecriticalbandsLabel  matlab.ui.control.Label
        UIAxes                          matlab.ui.control.UIAxes
    end

    
    properties (Access = private)
        Slider_1_Both=[100 100]; % 
        Slider_2_Both=[100 100]; % 
        Slider_3_Both=[100 100]; % 
        Slider_4_Both=[100 100]; % 
        Slider_5_Both=[100 100]; % 
        Slider_6_Both=[100 100]; % 
        Slider_7_Both=[100 100]; % 
        Slider_8_Both=[100 100]; % 
        Slider_9_Both=[100 100]; % 

        Slider_1_Left=[100 100]; % 
        Slider_2_Left=[100 100]; % 
        Slider_3_Left=[100 100]; % 
        Slider_4_Left=[100 100]; % 
        Slider_5_Left=[100 100]; % 
        Slider_6_Left=[100 100]; % 
        Slider_7_Left=[100 100]; % 
        Slider_8_Left=[100 100]; % 
        Slider_9_Left=[100 100]; % 

        Slider_1_Right=[100 100]; % 
        Slider_2_Right=[100 100]; % 
        Slider_3_Right=[100 100]; % 
        Slider_4_Right=[100 100]; % 
        Slider_5_Right=[100 100]; % 
        Slider_6_Right=[100 100]; % 
        Slider_7_Right=[100 100]; % 
        Slider_8_Right=[100 100]; % 
        Slider_9_Right=[100 100]; % 
        frequency=500;
        initialparameters=[-30 70 2];%%%Initial parameters
        freq=linspace(0, 3000, 1000);
        bandwidth=[25 50 75 100 150 200 300 400 500];
        ordenada=0;
        Critical_Band=0;%%Critical Band
        exponent=0;
        fitmodel=0;
        SS=1;%%%signalselected 1 500Hz  2 2000Hz
        ordinate_final=[0 0 0 0 0 0];
        critical_band_final=[0 0 0 0 0 0];
        exponent_final=[0 0 0 0 0 0];
    end
    
    properties (Access = public)
        filename; % Description
    end

    methods (Access = private)


        function updateplot(app)

            %%Dr. Ignacio Serrano-Pedraza 2023
            %%%With this program you can obtain the size of the critical band for two temporal
            %%%frequencies (500 Hz and 2000 Hz) using the method of adjustment.

            parameters=[app.ordenada app.Critical_Band app.exponent];

            if isequaln(app.Switch_3.Value,'On')==1  && isequaln(app.Switch_2.Value,'Off')==1 && isequaln(app.Switch_1.Value,'Off')==1
            
            x=app.bandwidth;
            y=[app.Slider_1_Both(app.SS) app.Slider_2_Both(app.SS) app.Slider_3_Both(app.SS) app.Slider_4_Both(app.SS)...
            app.Slider_5_Both(app.SS) app.Slider_6_Both(app.SS) app.Slider_7_Both(app.SS) app.Slider_8_Both(app.SS) app.Slider_9_Both(app.SS)]-app.Knob.Value;
            if app.fitmodel==1 && isequaln(app.BothEarsSwitch.Value,'On')==1
            bandw_large=[min(app.bandwidth):1:max(app.bandwidth)];
            prediction=piecewisefunction(bandw_large,parameters,app.freq,app.frequency);
            semilogx(app.UIAxes,x,y,'ko',bandw_large,prediction,'k-',[app.Critical_Band  app.Critical_Band ],[-50 180],'k--','Linewidth',2)
            th_text=['CB = ',num2str(app.Critical_Band,'%.2f'), ' Hz'];
            text(app.UIAxes,app.Critical_Band+app.Critical_Band*0.1,0, th_text, 'Color', 'k', 'FontSize',12)
            else
            semilogx(app.UIAxes,x,y,'ko','Linewidth',2)
            end
            legend(app.UIAxes,'Both Ears', 'Location','northwest')
            grid(app.UIAxes,'on');
            axis(app.UIAxes,[min(app.bandwidth)-min(app.bandwidth)*0.2 max(app.bandwidth)+max(app.bandwidth)*0.2 -10 80])
            hold(app.UIAxes,'off');


            end
            if isequaln(app.Switch_2.Value,'On')==1 && isequaln(app.Switch_3.Value,'Off')==1 && isequaln(app.Switch_1.Value,'Off')==1
            
            x=app.bandwidth;
            y_right=[app.Slider_1_Right(app.SS) app.Slider_2_Right(app.SS) app.Slider_3_Right(app.SS) app.Slider_4_Right(app.SS)...
            app.Slider_5_Right(app.SS) app.Slider_6_Right(app.SS) app.Slider_7_Right(app.SS) app.Slider_8_Right(app.SS) app.Slider_9_Right(app.SS)]-app.Knob.Value;
            if app.fitmodel==1 && isequaln(app.RightEarSwitch.Value,'On')==1 
            bandw_large=[min(app.bandwidth):1:max(app.bandwidth)];
            prediction=piecewisefunction(bandw_large,parameters,app.freq,app.frequency);
            semilogx(app.UIAxes,x,y_right,'ro',bandw_large,prediction,'r-',[app.Critical_Band  app.Critical_Band ],[-50 180],'r--','Linewidth',2)
            th_text=['CB = ',num2str(app.Critical_Band,'%.2f'), ' Hz'];
            text(app.UIAxes,app.Critical_Band+app.Critical_Band*0.1,0, th_text, 'Color', 'r', 'FontSize',12)
            else
            semilogx(app.UIAxes,x,y_right,'ro','Linewidth',2)
            end
            legend(app.UIAxes,'Right Ear',  'Location','northwest')
            grid(app.UIAxes,'on');
            axis(app.UIAxes,[min(app.bandwidth)-min(app.bandwidth)*0.2 max(app.bandwidth)+max(app.bandwidth)*0.2 -10 80])
            hold(app.UIAxes,'off');


           
            end

            if isequaln(app.Switch_1.Value,'On')==1  && isequaln(app.Switch_2.Value,'Off')==1 && isequaln(app.Switch_3.Value,'Off')==1
            x=app.bandwidth;
            y_left=[app.Slider_1_Left(app.SS) app.Slider_2_Left(app.SS) app.Slider_3_Left(app.SS) app.Slider_4_Left(app.SS)...
            app.Slider_5_Left(app.SS) app.Slider_6_Left(app.SS) app.Slider_7_Left(app.SS) app.Slider_8_Left(app.SS) app.Slider_9_Left(app.SS)]-app.Knob.Value;
             if app.fitmodel==1 && isequaln(app.LeftEarSwitch.Value,'On')==1
            bandw_large=[min(app.bandwidth):1:max(app.bandwidth)];
            prediction=piecewisefunction(bandw_large,parameters,app.freq,app.frequency);
            semilogx(app.UIAxes,x,y_left,'co',bandw_large,prediction,'c-',[app.Critical_Band  app.Critical_Band ],[-50 180],'c--','Linewidth',2)
            th_text=['CB = ',num2str(app.Critical_Band,'%.2f'), ' Hz'];
            text(app.UIAxes,app.Critical_Band+app.Critical_Band*0.1,0, th_text, 'Color', 'c', 'FontSize',12)
            else
            semilogx(app.UIAxes,x,y_left,'co','Linewidth',2)
            end
            legend(app.UIAxes,'Left Ear',  'Location','northwest')

            grid(app.UIAxes,'on');
            axis(app.UIAxes,[min(app.bandwidth)-min(app.bandwidth)*0.2 max(app.bandwidth)+max(app.bandwidth)*0.2 -10 80])
            hold(app.UIAxes,'off');

            
            end

           if isequaln(app.Switch_2.Value,'Off')==1 && isequaln(app.Switch_3.Value,'Off')==1 && isequaln(app.Switch_1.Value,'Off')==1
            
            x=10000*app.bandwidth;
            y_right=[app.Slider_1_Right(app.SS) app.Slider_2_Right(app.SS) app.Slider_3_Right(app.SS) app.Slider_4_Right(app.SS)...
            app.Slider_5_Right(app.SS) app.Slider_6_Right(app.SS) app.Slider_7_Right(app.SS) app.Slider_8_Right(app.SS) app.Slider_9_Right(app.SS)]-app.Knob.Value;
            semilogx(app.UIAxes,x,y_right,'k','Linewidth',2)
            legend(app.UIAxes,'off')
            grid(app.UIAxes,'on');
            axis(app.UIAxes,[min(app.bandwidth)-min(app.bandwidth)*0.2 max(app.bandwidth)+max(app.bandwidth)*0.2 -10 80])
            hold(app.UIAxes,'off');

            
            end
              
            if isequaln(app.Switch_2.Value,'On')==1 && isequaln(app.Switch_3.Value,'On')==1 && isequaln(app.Switch_1.Value,'Off')==1
            
            x=app.bandwidth;
            y_right=[app.Slider_1_Right(app.SS) app.Slider_2_Right(app.SS) app.Slider_3_Right(app.SS) app.Slider_4_Right(app.SS)...
            app.Slider_5_Right(app.SS) app.Slider_6_Right(app.SS) app.Slider_7_Right(app.SS) app.Slider_8_Right(app.SS) app.Slider_9_Right(app.SS)]-app.Knob.Value;
            y=[app.Slider_1_Both(app.SS) app.Slider_2_Both(app.SS) app.Slider_3_Both(app.SS) app.Slider_4_Both(app.SS)...
            app.Slider_5_Both(app.SS) app.Slider_6_Both(app.SS) app.Slider_7_Both(app.SS) app.Slider_8_Both(app.SS) app.Slider_9_Both(app.SS)]-app.Knob.Value;
            semilogx(app.UIAxes,x,y,'ko',x,y_right,'ro','Linewidth',2)
            legend(app.UIAxes,'Both Ears','Right Ear','Location','northwest')

            grid(app.UIAxes,'on');
            axis(app.UIAxes,[min(app.bandwidth)-min(app.bandwidth)*0.2 max(app.bandwidth)+max(app.bandwidth)*0.2 -10 80])
            hold(app.UIAxes,'off');

            
            end

            if isequaln(app.Switch_1.Value,'On')==1 && isequaln(app.Switch_3.Value,'On')==1 && isequaln(app.Switch_2.Value,'Off')==1
            
            x=app.bandwidth;
            y_left=[app.Slider_1_Left(app.SS) app.Slider_2_Left(app.SS) app.Slider_3_Left(app.SS) app.Slider_4_Left(app.SS)...
            app.Slider_5_Left(app.SS) app.Slider_6_Left(app.SS) app.Slider_7_Left(app.SS) app.Slider_8_Left(app.SS) app.Slider_9_Left(app.SS)]-app.Knob.Value;
            y=[app.Slider_1_Both(app.SS) app.Slider_2_Both(app.SS) app.Slider_3_Both(app.SS) app.Slider_4_Both(app.SS)...
            app.Slider_5_Both(app.SS) app.Slider_6_Both(app.SS) app.Slider_7_Both(app.SS) app.Slider_8_Both(app.SS) app.Slider_9_Both(app.SS)]-app.Knob.Value;
            semilogx(app.UIAxes,x,y_left,'co',x,y,'ko','Linewidth',2)
            legend(app.UIAxes,'Both Ears','Left Ear','Location','northwest')

            grid(app.UIAxes,'on');
            axis(app.UIAxes,[min(app.bandwidth)-min(app.bandwidth)*0.2 max(app.bandwidth)+max(app.bandwidth)*0.2 -10 80])
            hold(app.UIAxes,'off');

            
            end
            if isequaln(app.Switch_1.Value,'On')==1 && isequaln(app.Switch_2.Value,'On')==1 && isequaln(app.Switch_3.Value,'Off')==1
            
            x=app.bandwidth;
            y_left=[app.Slider_1_Left(app.SS) app.Slider_2_Left(app.SS) app.Slider_3_Left(app.SS) app.Slider_4_Left(app.SS)...
            app.Slider_5_Left(app.SS) app.Slider_6_Left(app.SS) app.Slider_7_Left(app.SS) app.Slider_8_Left(app.SS) app.Slider_9_Left(app.SS)]-app.Knob.Value;
            y_right=[app.Slider_1_Right(app.SS) app.Slider_2_Right(app.SS) app.Slider_3_Right(app.SS) app.Slider_4_Right(app.SS)...
            app.Slider_5_Right(app.SS) app.Slider_6_Right(app.SS) app.Slider_7_Right(app.SS) app.Slider_8_Right(app.SS) app.Slider_9_Right(app.SS)]-app.Knob.Value;
            semilogx(app.UIAxes,x,y_left,'co',x,y_right,'ro','Linewidth',2)
            legend(app.UIAxes,'Right Ear','Left Ear','Location','northwest')

            grid(app.UIAxes,'on');
            axis(app.UIAxes,[min(app.bandwidth)-min(app.bandwidth)*0.2 max(app.bandwidth)+max(app.bandwidth)*0.2 -10 80])
            hold(app.UIAxes,'off');

            end

            if isequaln(app.Switch_1.Value,'On')==1 && isequaln(app.Switch_2.Value,'On')==1 && isequaln(app.Switch_3.Value,'On')==1
            
            x=app.bandwidth;
            y=[app.Slider_1_Both(app.SS) app.Slider_2_Both(app.SS) app.Slider_3_Both(app.SS) app.Slider_4_Both(app.SS)...
            app.Slider_5_Both(app.SS) app.Slider_6_Both(app.SS) app.Slider_7_Both(app.SS) app.Slider_8_Both(app.SS) app.Slider_9_Both(app.SS)]-app.Knob.Value;
            y_left=[app.Slider_1_Left(app.SS) app.Slider_2_Left(app.SS) app.Slider_3_Left(app.SS) app.Slider_4_Left(app.SS)...
            app.Slider_5_Left(app.SS) app.Slider_6_Left(app.SS) app.Slider_7_Left(app.SS) app.Slider_8_Left(app.SS) app.Slider_9_Left(app.SS)]-app.Knob.Value;
            y_right=[app.Slider_1_Right(app.SS) app.Slider_2_Right(app.SS) app.Slider_3_Right(app.SS) app.Slider_4_Right(app.SS)...
            app.Slider_5_Right(app.SS) app.Slider_6_Right(app.SS) app.Slider_7_Right(app.SS) app.Slider_8_Right(app.SS) app.Slider_9_Right(app.SS)]-app.Knob.Value;
            semilogx(app.UIAxes,x,y_right,'ro',x,y_left,'co',x,y,'ko','Linewidth',2)
            legend(app.UIAxes,'Both Ears','Right Ear','Left Ear','Location','northwest')

            grid(app.UIAxes,'on');
            axis(app.UIAxes,[min(app.bandwidth)-min(app.bandwidth)*0.2 max(app.bandwidth)+max(app.bandwidth)*0.2 -10 80])
            hold(app.UIAxes,'off');

            
            end

function fitted_Y = piecewisefunction(bandwidth,parameters,freq,frequency)  
for j=1:length(bandwidth)
Bmin=app.frequency-bandwidth(j)/2;
Bmax=app.frequency+bandwidth(j)/2;
fun=@(freq) rectpuls(freq-app.frequency,parameters(2));
A(j)=integral(fun,Bmin,Bmax);
end
fitted_Y=real(parameters(1)+parameters(3)*20*log10(A));
end

            end
        
    end


    % Callbacks that handle component events
    methods (Access = private)

        % Value changed function: AHzSlider_1
        function AHzSlider_1ValueChanged(app, event)

           
%%%%%%%%%%%%%%%%%%%%SIGNAL%%%%%%%%%%%%%%%%%%%%%%%%          

            volumen_dB = app.AHzSlider_1.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*app.frequency*t);

%%%%%%%%%%%%%%%%%%%%BAND-PASS NOISE%%%%%%%%%%%%%%%%%%%

n=length(t);
freq=(-fix(n/2):fix((n-1)/2))/duration;
noise=randn(n,1);
Y=fftshift(fft(noise));
modulo=abs(Y)';
fase=angle(Y)';
central=app.frequency;
ucsupA=central-app.bandwidth(1)/2;
ucsupB=central+app.bandwidth(1)/2;
ucinfA=-ucsupB;
ucinfB=-ucsupA;
J=find(freq>ucinfA&freq<ucinfB|freq>ucsupA&freq<ucsupB);
filtroPBANDA=0*ones(1,length(freq));%
filtroPBANDA(J)=1;%%
filtro=filtroPBANDA;
REALPROD=fftshift(modulo.*filtro.*cos(fase));
IMAGPROD=fftshift(modulo.*filtro.*sin(fase));
RESULTADO=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=(ifft(RESULTADO));
FINALREAL=real(FINAL);
N0=10^((-75)/20)*0.75;%% 
CRMS=sqrt(N0*app.bandwidth(1));%%pp. 48 Hartmann 
RR= 0 + CRMS * FINALREAL';
R=(R+RR)/2; %%Signal+Noise
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

            if isequaln(app.LeftEarSwitch.Value,'On')==1
                            app.Slider_1_Left(app.SS)=app.AHzSlider_1.Value;

            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                            app.Slider_1_Right(app.SS)=app.AHzSlider_1.Value;

            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_1_Both(app.SS)=app.AHzSlider_1.Value;
           
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_2
        function AHzSlider_2ValueChanged(app, event)
%%%%%%%%%%%%%%%%%%%%SIGNAL%%%%%%%%%%%%%%%%%%%%%%%%          

            volumen_dB = app.AHzSlider_2.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*app.frequency*t);

%%%%%%%%%%%%%%%%%%%%BAND-PASS NOISE%%%%%%%%%%%%%%%%%%%

n=length(t);
freq=(-fix(n/2):fix((n-1)/2))/duration;
noise=randn(n,1);
Y=fftshift(fft(noise));
modulo=abs(Y)';
fase=angle(Y)';
central=app.frequency;
ucsupA=central-app.bandwidth(2)/2;
ucsupB=central+app.bandwidth(2)/2;
ucinfA=-ucsupB;
ucinfB=-ucsupA;
J=find(freq>ucinfA&freq<ucinfB|freq>ucsupA&freq<ucsupB);
filtroPBANDA=0*ones(1,length(freq));%
filtroPBANDA(J)=1;%%
filtro=filtroPBANDA;
REALPROD=fftshift(modulo.*filtro.*cos(fase));
IMAGPROD=fftshift(modulo.*filtro.*sin(fase));
RESULTADO=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=(ifft(RESULTADO));
FINALREAL=real(FINAL);
N0=10^((-75)/20)*0.75;%% 
CRMS=sqrt(N0*app.bandwidth(1));%%pp. 48 Hartmann 
RR= 0 + CRMS * FINALREAL';
R=(R+RR)/2; %%Signal+Noise
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            if isequaln(app.LeftEarSwitch.Value,'On')==1
            app.Slider_2_Left(app.SS)=app.AHzSlider_2.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
            app.Slider_2_Right(app.SS)=app.AHzSlider_2.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
                app.Slider_2_Both(app.SS)=app.AHzSlider_2.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_3
        function AHzSlider_3ValueChanged(app, event)
           %%%%%%%%%%%%%%%%%%%%SIGNAL%%%%%%%%%%%%%%%%%%%%%%%%          

            volumen_dB = app.AHzSlider_3.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*app.frequency*t);

%%%%%%%%%%%%%%%%%%%%BAND-PASS NOISE%%%%%%%%%%%%%%%%%%%

n=length(t);
freq=(-fix(n/2):fix((n-1)/2))/duration;
noise=randn(n,1);
Y=fftshift(fft(noise));
modulo=abs(Y)';
fase=angle(Y)';
central=app.frequency;
ucsupA=central-app.bandwidth(3)/2;
ucsupB=central+app.bandwidth(3)/2;
ucinfA=-ucsupB;
ucinfB=-ucsupA;
J=find(freq>ucinfA&freq<ucinfB|freq>ucsupA&freq<ucsupB);
filtroPBANDA=0*ones(1,length(freq));%
filtroPBANDA(J)=1;%%
filtro=filtroPBANDA;
REALPROD=fftshift(modulo.*filtro.*cos(fase));
IMAGPROD=fftshift(modulo.*filtro.*sin(fase));
RESULTADO=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=(ifft(RESULTADO));
FINALREAL=real(FINAL);
N0=10^((-75)/20)*0.75;%% 
CRMS=sqrt(N0*app.bandwidth(1));%%pp. 48 Hartmann 
RR= 0 + CRMS * FINALREAL';
R=(R+RR)/2; %%Signal+Noise
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_3_Left(app.SS)=app.AHzSlider_3.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_3_Right(app.SS)=app.AHzSlider_3.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
                app.Slider_3_Both(app.SS)=app.AHzSlider_3.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_4
        function AHzSlider_4ValueChanged(app, event)
            %%%%%%%%%%%%%%%%%%%%SIGNAL%%%%%%%%%%%%%%%%%%%%%%%%          

            volumen_dB = app.AHzSlider_4.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*app.frequency*t);

%%%%%%%%%%%%%%%%%%%%BAND-PASS NOISE%%%%%%%%%%%%%%%%%%%

n=length(t);
freq=(-fix(n/2):fix((n-1)/2))/duration;
noise=randn(n,1);
Y=fftshift(fft(noise));
modulo=abs(Y)';
fase=angle(Y)';
central=app.frequency;
ucsupA=central-app.bandwidth(4)/2;
ucsupB=central+app.bandwidth(4)/2;
ucinfA=-ucsupB;
ucinfB=-ucsupA;
J=find(freq>ucinfA&freq<ucinfB|freq>ucsupA&freq<ucsupB);
filtroPBANDA=0*ones(1,length(freq));%
filtroPBANDA(J)=1;%%
filtro=filtroPBANDA;
REALPROD=fftshift(modulo.*filtro.*cos(fase));
IMAGPROD=fftshift(modulo.*filtro.*sin(fase));
RESULTADO=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=(ifft(RESULTADO));
FINALREAL=real(FINAL);
N0=10^((-75)/20)*0.75;%% 
CRMS=sqrt(N0*app.bandwidth(1));%%pp. 48 Hartmann 
RR= 0 + CRMS * FINALREAL';
R=(R+RR)/2; %%Signal+Noise
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                 app.Slider_4_Left(app.SS)=app.AHzSlider_4.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                 app.Slider_4_Right(app.SS)=app.AHzSlider_4.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
                app.Slider_4_Both(app.SS)=app.AHzSlider_4.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_5
        function AHzSlider_5ValueChanged(app, event)
            %%%%%%%%%%%%%%%%%%%%SIGNAL%%%%%%%%%%%%%%%%%%%%%%%%          

            volumen_dB = app.AHzSlider_5.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*app.frequency*t);

%%%%%%%%%%%%%%%%%%%%BAND-PASS NOISE%%%%%%%%%%%%%%%%%%%

n=length(t);
freq=(-fix(n/2):fix((n-1)/2))/duration;
noise=randn(n,1);
Y=fftshift(fft(noise));
modulo=abs(Y)';
fase=angle(Y)';
central=app.frequency;
ucsupA=central-app.bandwidth(5)/2;
ucsupB=central+app.bandwidth(5)/2;
ucinfA=-ucsupB;
ucinfB=-ucsupA;
J=find(freq>ucinfA&freq<ucinfB|freq>ucsupA&freq<ucsupB);
filtroPBANDA=0*ones(1,length(freq));%
filtroPBANDA(J)=1;%%
filtro=filtroPBANDA;
REALPROD=fftshift(modulo.*filtro.*cos(fase));
IMAGPROD=fftshift(modulo.*filtro.*sin(fase));
RESULTADO=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=(ifft(RESULTADO));
FINALREAL=real(FINAL);
N0=10^((-75)/20)*0.75;%% 
CRMS=sqrt(N0*app.bandwidth(1));%%pp. 48 Hartmann 
RR= 0 + CRMS * FINALREAL';
R=(R+RR)/2; %%Signal+Noise
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_5_Left(app.SS)=app.AHzSlider_5.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_5_Right(app.SS)=app.AHzSlider_5.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_5_Both(app.SS)=app.AHzSlider_5.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_6
        function AHzSlider_6ValueChanged(app, event)
            %%%%%%%%%%%%%%%%%%%%SIGNAL%%%%%%%%%%%%%%%%%%%%%%%%          

            volumen_dB = app.AHzSlider_6.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*app.frequency*t);

%%%%%%%%%%%%%%%%%%%%BAND-PASS NOISE%%%%%%%%%%%%%%%%%%%

n=length(t);
freq=(-fix(n/2):fix((n-1)/2))/duration;
noise=randn(n,1);
Y=fftshift(fft(noise));
modulo=abs(Y)';
fase=angle(Y)';
central=app.frequency;
ucsupA=central-app.bandwidth(6)/2;
ucsupB=central+app.bandwidth(6)/2;
ucinfA=-ucsupB;
ucinfB=-ucsupA;
J=find(freq>ucinfA&freq<ucinfB|freq>ucsupA&freq<ucsupB);
filtroPBANDA=0*ones(1,length(freq));%
filtroPBANDA(J)=1;%%
filtro=filtroPBANDA;
REALPROD=fftshift(modulo.*filtro.*cos(fase));
IMAGPROD=fftshift(modulo.*filtro.*sin(fase));
RESULTADO=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=(ifft(RESULTADO));
FINALREAL=real(FINAL);
N0=10^((-75)/20)*0.75;%% 
CRMS=sqrt(N0*app.bandwidth(1));%%pp. 48 Hartmann 
RR= 0 + CRMS * FINALREAL';
R=(R+RR)/2; %%Signal+Noise
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_6_Left(app.SS)=app.AHzSlider_6.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_6_Right(app.SS)=app.AHzSlider_6.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_6_Both(app.SS)=app.AHzSlider_6.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_7
        function AHzSlider_7ValueChanged(app, event)
            %%%%%%%%%%%%%%%%%%%%SIGNAL%%%%%%%%%%%%%%%%%%%%%%%%          

            volumen_dB = app.AHzSlider_7.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*app.frequency*t);

%%%%%%%%%%%%%%%%%%%%BAND-PASS NOISE%%%%%%%%%%%%%%%%%%%

n=length(t);
freq=(-fix(n/2):fix((n-1)/2))/duration;
noise=randn(n,1);
Y=fftshift(fft(noise));
modulo=abs(Y)';
fase=angle(Y)';
central=app.frequency;
ucsupA=central-app.bandwidth(7)/2;
ucsupB=central+app.bandwidth(7)/2;
ucinfA=-ucsupB;
ucinfB=-ucsupA;
J=find(freq>ucinfA&freq<ucinfB|freq>ucsupA&freq<ucsupB);
filtroPBANDA=0*ones(1,length(freq));%
filtroPBANDA(J)=1;%%
filtro=filtroPBANDA;
REALPROD=fftshift(modulo.*filtro.*cos(fase));
IMAGPROD=fftshift(modulo.*filtro.*sin(fase));
RESULTADO=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=(ifft(RESULTADO));
FINALREAL=real(FINAL);
N0=10^((-75)/20)*0.75;%% 
CRMS=sqrt(N0*app.bandwidth(1));%%pp. 48 Hartmann 
RR= 0 + CRMS * FINALREAL';
R=(R+RR)/2; %%Signal+Noise
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_7_Left(app.SS)=app.AHzSlider_7.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_7_Right(app.SS)=app.AHzSlider_7.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_7_Both(app.SS)=app.AHzSlider_7.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_8
        function AHzSlider_8ValueChanged(app, event)

           %%%%%%%%%%%%%%%%%%%%SIGNAL%%%%%%%%%%%%%%%%%%%%%%%%          

            volumen_dB = app.AHzSlider_8.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*app.frequency*t);

%%%%%%%%%%%%%%%%%%%%BAND-PASS NOISE%%%%%%%%%%%%%%%%%%%

n=length(t);
freq=(-fix(n/2):fix((n-1)/2))/duration;
noise=randn(n,1);
Y=fftshift(fft(noise));
modulo=abs(Y)';
fase=angle(Y)';
central=app.frequency;
ucsupA=central-app.bandwidth(8)/2;
ucsupB=central+app.bandwidth(8)/2;
ucinfA=-ucsupB;
ucinfB=-ucsupA;
J=find(freq>ucinfA&freq<ucinfB|freq>ucsupA&freq<ucsupB);
filtroPBANDA=0*ones(1,length(freq));%
filtroPBANDA(J)=1;%%
filtro=filtroPBANDA;
REALPROD=fftshift(modulo.*filtro.*cos(fase));
IMAGPROD=fftshift(modulo.*filtro.*sin(fase));
RESULTADO=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=(ifft(RESULTADO));
FINALREAL=real(FINAL);
N0=10^((-75)/20)*0.75;%% 
CRMS=sqrt(N0*app.bandwidth(1));%%pp. 48 Hartmann 
RR= 0 + CRMS * FINALREAL';
R=(R+RR)/2; %%Signal+Noise
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_8_Left(app.SS)=app.AHzSlider_8.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_8_Right(app.SS)=app.AHzSlider_8.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_8_Both(app.SS)=app.AHzSlider_8.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
        end

        % Value changed function: AHzSlider_9
        function AHzSlider_9ValueChanged(app, event)
                       %%%%%%%%%%%%%%%%%%%%SIGNAL%%%%%%%%%%%%%%%%%%%%%%%%          

            volumen_dB = app.AHzSlider_9.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*app.frequency*t);

%%%%%%%%%%%%%%%%%%%%BAND-PASS NOISE%%%%%%%%%%%%%%%%%%%

n=length(t);
freq=(-fix(n/2):fix((n-1)/2))/duration;
noise=randn(n,1);
Y=fftshift(fft(noise));
modulo=abs(Y)';
fase=angle(Y)';
central=app.frequency;
ucsupA=central-app.bandwidth(9)/2;
ucsupB=central+app.bandwidth(9)/2;
ucinfA=-ucsupB;
ucinfB=-ucsupA;
J=find(freq>ucinfA&freq<ucinfB|freq>ucsupA&freq<ucsupB);
filtroPBANDA=0*ones(1,length(freq));%
filtroPBANDA(J)=1;%%
filtro=filtroPBANDA;
REALPROD=fftshift(modulo.*filtro.*cos(fase));
IMAGPROD=fftshift(modulo.*filtro.*sin(fase));
RESULTADO=(REALPROD+IMAGPROD*sqrt(-1));
FINAL=(ifft(RESULTADO));
FINALREAL=real(FINAL);
N0=10^((-75)/20)*0.75;%% 
CRMS=sqrt(N0*app.bandwidth(1));%%pp. 48 Hartmann 
RR= 0 + CRMS * FINALREAL';
R=(R+RR)/2; %%Signal+Noise
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


            if isequaln(app.LeftEarSwitch.Value,'On')==1
                app.Slider_9_Left(app.SS)=app.AHzSlider_9.Value;
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
                app.Slider_9_Right(app.SS)=app.AHzSlider_9.Value;
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.Slider_9_Both(app.SS)=app.AHzSlider_9.Value;
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            app.updateplot
            
        end

        % Value changed function: Knob
        function KnobValueChanged(app, event)
            volumen_dB =  app.Knob.Value-100;
            samplingrate=44100;
            duration=1; %seconds
            t=[0+(1/samplingrate):1/samplingrate:duration]';
            Amplitude=10^((volumen_dB)/20)*0.75;
            R=Amplitude*cos(2*pi*2000*t);
            

            if isequaln(app.LeftEarSwitch.Value,'On')==1
            R=[R 0*R];%%Left speaker
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
            R=[0*R R];%%Right speaker
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            R=[R R];%%Both ears
            end
            sound(R,samplingrate)
            %app.updateplot
        end

        % Button pushed function: FitmodelButton
        function FitmodelButtonPushed(app, event)
            if isequaln(app.LeftEarSwitch.Value,'On')==1
            Thresholds=[app.Slider_1_Left(app.SS) app.Slider_2_Left(app.SS) app.Slider_3_Left(app.SS) app.Slider_4_Left(app.SS)...
            app.Slider_5_Left(app.SS) app.Slider_6_Left(app.SS) app.Slider_7_Left(app.SS) app.Slider_8_Left(app.SS) app.Slider_9_Left(app.SS)]-app.Knob.Value;
            end
            if isequaln(app.RightEarSwitch.Value,'On')==1
            Thresholds=[app.Slider_1_Right(app.SS) app.Slider_2_Right(app.SS) app.Slider_3_Right(app.SS) app.Slider_4_Right(app.SS)...
            app.Slider_5_Right(app.SS) app.Slider_6_Right(app.SS) app.Slider_7_Right(app.SS) app.Slider_8_Right(app.SS) app.Slider_9_Right(app.SS)]-app.Knob.Value;
            end
            if isequaln(app.BothEarsSwitch.Value,'On')==1
            Thresholds=[app.Slider_1_Both(app.SS) app.Slider_2_Both(app.SS) app.Slider_3_Both(app.SS) app.Slider_4_Both(app.SS)...
            app.Slider_5_Both(app.SS) app.Slider_6_Both(app.SS) app.Slider_7_Both(app.SS) app.Slider_8_Both(app.SS) app.Slider_9_Both(app.SS)]-app.Knob.Value;
            end

fmin=0;
fmax=3000;
app.freq=linspace(fmin, fmax, 1000);
CB=24.7*(1+4.37*(10^-3*app.frequency));%%%Critical band

opts = statset('nlinfit');
opts.MaxFunEvals=500;
opts.MaxIter=500;
opts.TolX=1E-15;
opts.TolFun=1E-15;
%%opts.Display='iter';

initialparameters=[-30 CB 2];%%%Initial parameters
band=app.bandwidth;

modelFun = @(initialparameters,band) piecewisefunction(band,initialparameters,app.freq,app.frequency);

[beta,resid,J,Sigma,mse] = nlinfit(band, Thresholds, modelFun,initialparameters,opts);
app.ordenada=beta(1);%%%
app.Critical_Band=beta(2);%%Critical Band
app.exponent=beta(3);

function fitted_Y = piecewisefunction(bandwidth,initialparameters,freq,frequency)  
for j=1:length(app.bandwidth)
Bmin=app.frequency-app.bandwidth(j)/2;
Bmax=app.frequency+app.bandwidth(j)/2;
fun=@(freq) rectpuls(freq-app.frequency,initialparameters(2));
A(j)=integral(fun,Bmin,Bmax);
end
fitted_Y=real(initialparameters(1)+initialparameters(3)*20*log10(A));
end

app.fitmodel=1;
if isequaln(app.BothEarsSwitch.Value,'On')==1 && app.SS==1
        app.ordinate_final(1)=app.ordenada;
        app.critical_band_final(1)=app.Critical_Band;
        app.exponent_final(1)=app.exponent;

end
if isequaln(app.LeftEarSwitch.Value,'On')==1 && app.SS==1
        app.ordinate_final(2)=app.ordenada;
        app.critical_band_final(2)=app.Critical_Band;
        app.exponent_final(2)=app.exponent;
end
if isequaln(app.RightEarSwitch.Value,'On')==1 && app.SS==1
        app.ordinate_final(3)=app.ordenada;
        app.critical_band_final(3)=app.Critical_Band;
        app.exponent_final(3)=app.exponent;
end
if isequaln(app.BothEarsSwitch.Value,'On')==1 && app.SS==2
        app.ordinate_final(4)=app.ordenada;
        app.critical_band_final(4)=app.Critical_Band;
        app.exponent_final(4)=app.exponent;

end
if isequaln(app.LeftEarSwitch.Value,'On')==1 && app.SS==2
        app.ordinate_final(5)=app.ordenada;
        app.critical_band_final(5)=app.Critical_Band;
        app.exponent_final(5)=app.exponent;
end
if isequaln(app.RightEarSwitch.Value,'On')==1 && app.SS==2
        app.ordinate_final(6)=app.ordenada;
        app.critical_band_final(6)=app.Critical_Band;
        app.exponent_final(6)=app.exponent;
end

app.updateplot;
        end

        % Button pushed function: RemovefittingButton
        function RemovefittingButtonPushed(app, event)

app.fitmodel=0;
app.updateplot;
        end

        % Button pushed function: PressthisbuttonwhenreadyButton
        function PressthisbuttonwhenreadyButtonPushed(app, event)



            app.RecalibratevolumeButton.Enable='on';
            app.RestartButton.Enable='on';
            app.SavedataButton.Enable='on';
            app.AgeEditField.Enable='on';
            app.AgeEditFieldLabel.Enable='on';
            app.InitialsEditField.Enable='on';
            app.InitialsEditFieldLabel.Enable='on';

            app.Knob.Enable= 'off';
            app.PressthisbuttonwhenreadyButton.Enable='off';
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.Enable='off';
            app.VolumecalibrationLabel.Enable='off';
            app.AHzSlider_1.Enable = 'on';
            app.AHzSlider_2.Enable = 'on';
            app.AHzSlider_3.Enable = 'on';
            app.AHzSlider_4.Enable = 'on';
            app.AHzSlider_5.Enable = 'on';
            app.AHzSlider_6.Enable = 'on';
            app.AHzSlider_7.Enable = 'on';
            app.AHzSlider_8.Enable = 'on';
            app.AHzSlider_9.Enable = 'on';
            app.UIAxes.Visible='on';
            app.BandwidthofthebandpassnoiseLabel.Enable= 'on';
            app.AdjusttheslideruntilyoudonthearthesignalinsertedinnoiseLabel.Enable= 'on';

            app.HzLabel_1.Enable = 'on';
            app.HzLabel_2.Enable = 'on';
            app.HzLabel_3.Enable = 'on';
            app.HzLabel_4.Enable = 'on';
            app.HzLabel_5.Enable = 'on';
            app.HzLabel_6.Enable = 'on';
            app.HzLabel_7.Enable = 'on';
            app.HzLabel_8.Enable = 'on';
            app.HzLabel_9.Enable = 'on';

            app.RightEarSwitch.Enable= 'On';
            app.LeftEarSwitch.Enable= 'On';
            app.BothEarsSwitch.Enable= 'On';
            app.Lamp_1.Enable= 'On';
            app.Lamp_2.Enable= 'On';
            app.Lamp_3.Enable= 'On';
            app.LeftEarSwitch.Value= 'Off';
            app.RightEarSwitch.Value= 'Off';
            app.Switch_1.Enable = 'On';
            app.Switch_2.Enable = 'On';
            app.Switch_3.Enable = 'On';

            app.FitmodelButton.Enable='On'; 
            app.RemovefittingButton.Enable='On'; 

            app.TemporalFrequencyofthesignalButtonGroup.Enable='On';
            app.HzButton_2000.Enable='On';
            app.HzButton_500.Enable='On';
if app.HzButton_500.Value==1
app.HzLabel_1.Text = '25 Hz';
app.HzLabel_2.Text = '50 Hz';
app.HzLabel_3.Text = '75 Hz';
app.HzLabel_4.Text = '100 Hz';
app.HzLabel_5.Text = '150 Hz';
app.HzLabel_6.Text = '200 Hz';
app.HzLabel_7.Text = '300 Hz';
app.HzLabel_8.Text = '400 Hz';
app.HzLabel_9.Text = '500 Hz';
app.frequency=500;
app.bandwidth=[25 50 75 100 150 200 300 400 500];
            app.UIAxes.XTick = app.bandwidth;
            app.UIAxes.XTickLabel = {'25'; '50'; '75'; '100'; '150'; '200'; '300'; '400'; '500'};
end
if app.HzButton_2000.Value==1
app.HzLabel_1.Text = '50 Hz';
app.HzLabel_2.Text = '100 Hz';
app.HzLabel_3.Text = '200 Hz';
app.HzLabel_4.Text = '250 Hz';
app.HzLabel_5.Text = '300 Hz';
app.HzLabel_6.Text = '400 Hz';
app.HzLabel_7.Text = '600 Hz';
app.HzLabel_8.Text = '800 Hz';
app.HzLabel_9.Text = '1600 Hz';
app.frequency=2000;
app.bandwidth=[50 100 200 250 300 400 600 800 1600];
            app.UIAxes.XTick = app.bandwidth;
            app.UIAxes.XTickLabel = {'50'; '100'; '200'; '250'; '300'; '400'; '600'; '800'; '1600'};
end


            app.updateplot;
        end

        % Button pushed function: RecalibratevolumeButton
        function RecalibratevolumeButtonPushed(app, event)
            app.RecalibratevolumeButton.Enable='off';
            app.RestartButton.Enable='off';
            app.SavedataButton.Enable='off';
            app.AgeEditField.Enable='off';
            app.AgeEditFieldLabel.Enable='off';
            app.InitialsEditField.Enable='off';
            app.InitialsEditFieldLabel.Enable='off';

            app.Knob.Enable= 'on';
            app.PressthisbuttonwhenreadyButton.Enable='on';
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.Enable='on';
            app.VolumecalibrationLabel.Enable='on';
            app.AHzSlider_1.Enable = 'off';
            app.AHzSlider_2.Enable = 'off';
            app.AHzSlider_3.Enable = 'off';
            app.AHzSlider_4.Enable = 'off';
            app.AHzSlider_5.Enable = 'off';
            app.AHzSlider_6.Enable = 'off';
            app.AHzSlider_7.Enable = 'off';
            app.AHzSlider_8.Enable = 'off';
            app.AHzSlider_9.Enable = 'off';
            app.UIAxes.Visible='on';
            app.BandwidthofthebandpassnoiseLabel.Enable= 'off';
            app.AdjusttheslideruntilyoudonthearthesignalinsertedinnoiseLabel.Enable= 'off';

            app.HzLabel_1.Enable = 'off';
            app.HzLabel_2.Enable = 'off';
            app.HzLabel_3.Enable = 'off';
            app.HzLabel_4.Enable = 'off';
            app.HzLabel_5.Enable = 'off';
            app.HzLabel_6.Enable = 'off';
            app.HzLabel_7.Enable = 'off';
            app.HzLabel_8.Enable = 'off';
            app.HzLabel_9.Enable = 'off';

            app.RightEarSwitch.Enable= 'Off';
            app.LeftEarSwitch.Enable= 'Off';
            app.BothEarsSwitch.Enable= 'Off';
            app.BothEarsSwitch.Value= 'On';
            app.Lamp_1.Enable= 'Off';
            app.Lamp_2.Enable= 'Off';
            app.Lamp_3.Enable= 'Off';
            app.Lamp_1.Color = [0 1 0];
            app.Lamp_2.Color = [1 0 0];
            app.Lamp_3.Color = [1 0 0];

            app.Switch_1.Enable = 'Off';
            app.Switch_2.Enable = 'Off';
            app.Switch_3.Enable = 'Off';

            app.FitmodelButton.Enable='Off'; 
            app.RemovefittingButton.Enable='Off'; 

            app.TemporalFrequencyofthesignalButtonGroup.Enable='Off';
            app.HzButton_2000.Enable='Off';
            app.HzButton_500.Enable='Off';
        end

        % Button pushed function: RestartButton
        function RestartButtonPushed(app, event)
            app.RecalibratevolumeButton.Enable='off';
            app.RestartButton.Enable='off';
            app.SavedataButton.Enable='off';
            app.AgeEditField.Enable='off';
            app.AgeEditFieldLabel.Enable='off';
            app.InitialsEditField.Enable='off';
            app.InitialsEditFieldLabel.Enable='off';
            app.AgeEditField.Value='';
            app.InitialsEditField.Value='';
            app.Knob.Enable= 'on';
            app.PressthisbuttonwhenreadyButton.Enable='on';
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.Enable='on';
            app.VolumecalibrationLabel.Enable='on';
            app.AHzSlider_1.Enable = 'off';
            app.AHzSlider_2.Enable = 'off';
            app.AHzSlider_3.Enable = 'off';
            app.AHzSlider_4.Enable = 'off';
            app.AHzSlider_5.Enable = 'off';
            app.AHzSlider_6.Enable = 'off';
            app.AHzSlider_7.Enable = 'off';
            app.AHzSlider_8.Enable = 'off';
            app.AHzSlider_9.Enable = 'off';

            app.BandwidthofthebandpassnoiseLabel.Enable= 'off';
            app.AdjusttheslideruntilyoudonthearthesignalinsertedinnoiseLabel.Enable= 'off';

            app.HzLabel_1.Enable = 'off';
            app.HzLabel_2.Enable = 'off';
            app.HzLabel_3.Enable = 'off';
            app.HzLabel_4.Enable = 'off';
            app.HzLabel_5.Enable = 'off';
            app.HzLabel_6.Enable = 'off';
            app.HzLabel_7.Enable = 'off';
            app.HzLabel_8.Enable = 'off';
            app.HzLabel_9.Enable = 'off';

            app.RightEarSwitch.Enable= 'Off';
            app.LeftEarSwitch.Enable= 'Off';
            app.BothEarsSwitch.Enable= 'Off';
            app.BothEarsSwitch.Value= 'On';
            app.Lamp_1.Enable= 'On';
            app.Lamp_2.Enable= 'Off';
            app.Lamp_3.Enable= 'Off';
            app.Lamp_1.Color = [0 1 0];
            app.Lamp_2.Color = [1 0 0];
            app.Lamp_3.Color = [1 0 0];
            
            app.AHzSlider_1.Value=100;
            app.AHzSlider_2.Value=100;
            app.AHzSlider_3.Value=100;
            app.AHzSlider_4.Value=100;
            app.AHzSlider_5.Value=100;
            app.AHzSlider_6.Value=100;
            app.AHzSlider_7.Value=100;
            app.AHzSlider_8.Value=100;
            app.AHzSlider_9.Value=100;

        app.Slider_1_Both=[100 100]; % 
        app.Slider_2_Both=[100 100]; % 
        app.Slider_3_Both=[100 100]; % 
        app.Slider_4_Both=[100 100]; % 
        app.Slider_5_Both=[100 100]; % 
        app.Slider_6_Both=[100 100]; % 
        app.Slider_7_Both=[100 100]; % 
        app.Slider_8_Both=[100 100]; % 
        app.Slider_9_Both=[100 100]; % 

        app.Slider_1_Left=[100 100]; % 
        app.Slider_2_Left=[100 100]; % 
        app.Slider_3_Left=[100 100]; % 
        app.Slider_4_Left=[100 100]; % 
        app.Slider_5_Left=[100 100]; % 
        app.Slider_6_Left=[100 100]; % 
        app.Slider_7_Left=[100 100]; % 
        app.Slider_8_Left=[100 100]; % 
        app.Slider_9_Left=[100 100]; % 

        app.Slider_1_Right=[100 100]; % 
        app.Slider_2_Right=[100 100]; % 
        app.Slider_3_Right=[100 100]; % 
        app.Slider_4_Right=[100 100]; % 
        app.Slider_5_Right=[100 100]; % 
        app.Slider_6_Right=[100 100]; % 
        app.Slider_7_Right=[100 100]; % 
        app.Slider_8_Right=[100 100]; % 
        app.Slider_9_Right=[100 100]; % 

            app.Switch_1.Enable = 'Off';
            app.Switch_2.Enable = 'Off';
            app.Switch_3.Enable = 'Off';
            app.Switch_1.Value = 'Off';
            app.Switch_2.Value= 'Off';
            app.Switch_3.Value = 'On';

            app.FitmodelButton.Enable='Off'; 
            app.RemovefittingButton.Enable='Off'; 

            app.TemporalFrequencyofthesignalButtonGroup.Enable='Off';
            app.HzButton_2000.Enable='Off';
            app.HzButton_500.Enable='Off';

if app.HzButton_500.Value==1
app.HzLabel_1.Text = '25 Hz';
app.HzLabel_2.Text = '50 Hz';
app.HzLabel_3.Text = '75 Hz';
app.HzLabel_4.Text = '100 Hz';
app.HzLabel_5.Text = '150 Hz';
app.HzLabel_6.Text = '200 Hz';
app.HzLabel_7.Text = '300 Hz';
app.HzLabel_8.Text = '400 Hz';
app.HzLabel_9.Text = '500 Hz';
app.frequency=500;
app.bandwidth=[25 50 75 100 150 200 300 400 500];
            app.UIAxes.XTick = app.bandwidth;
            app.UIAxes.XTickLabel = {'25'; '50'; '75'; '100'; '150'; '200'; '300'; '400'; '500'};
end
if app.HzButton_2000.Value==1
app.HzLabel_1.Text = '50 Hz';
app.HzLabel_2.Text = '100 Hz';
app.HzLabel_3.Text = '200 Hz';
app.HzLabel_4.Text = '250 Hz';
app.HzLabel_5.Text = '300 Hz';
app.HzLabel_6.Text = '400 Hz';
app.HzLabel_7.Text = '600 Hz';
app.HzLabel_8.Text = '800 Hz';
app.HzLabel_9.Text = '1600 Hz';
app.frequency=2000;
app.bandwidth=[50 100 200 250 300 400 600 800 1600];
            app.UIAxes.XTick = app.bandwidth;
            app.UIAxes.XTickLabel = {'50'; '100'; '200'; '250'; '300'; '400'; '600'; '800'; '1600'};
end
            app.fitmodel=0;
            app.updateplot;
        end

        % Value changed function: BothEarsSwitch
        function BothEarsSwitchValueChanged(app, event)
            value = app.BothEarsSwitch.Value;
            app.LeftEarSwitch.Value= 'Off';
            app.RightEarSwitch.Value= 'Off';
            app.BothEarsSwitch.Value= 'On';
            app.Lamp_1.Color = [0 1 0];
            app.Lamp_2.Color = [1 0 0];
            app.Lamp_3.Color = [1 0 0];
            app.AHzSlider_1.Value=app.Slider_1_Both(app.SS);
            app.AHzSlider_2.Value=app.Slider_2_Both(app.SS);
            app.AHzSlider_3.Value=app.Slider_3_Both(app.SS);
            app.AHzSlider_4.Value=app.Slider_4_Both(app.SS);
            app.AHzSlider_5.Value=app.Slider_5_Both(app.SS);
            app.AHzSlider_6.Value=app.Slider_6_Both(app.SS);
            app.AHzSlider_7.Value=app.Slider_7_Both(app.SS);
            app.AHzSlider_8.Value=app.Slider_8_Both(app.SS);
            app.AHzSlider_9.Value=app.Slider_9_Both(app.SS);
            app.Switch_3.Value = 'On';
            app.Switch_2.Value = 'Off';
            app.Switch_1.Value = 'Off';
            if app.fitmodel==1
            app.FitmodelButtonPushed;
            end
            app.updateplot;
        end

        % Value changed function: LeftEarSwitch
        function LeftEarSwitchValueChanged(app, event)
            value = app.LeftEarSwitch.Value;
            app.BothEarsSwitch.Value= 'Off';
            app.RightEarSwitch.Value= 'Off';
            app.LeftEarSwitch.Value= 'On';
            app.Lamp_1.Color = [1 0 0];
            app.Lamp_2.Color = [1 0 0];
            app.Lamp_3.Color = [0 1 0]; 
            app.AHzSlider_1.Value=app.Slider_1_Left(app.SS);
            app.AHzSlider_2.Value=app.Slider_2_Left(app.SS);
            app.AHzSlider_3.Value=app.Slider_3_Left(app.SS);
            app.AHzSlider_4.Value=app.Slider_4_Left(app.SS);
            app.AHzSlider_5.Value=app.Slider_5_Left(app.SS);
            app.AHzSlider_6.Value=app.Slider_6_Left(app.SS);
            app.AHzSlider_7.Value=app.Slider_7_Left(app.SS);
            app.AHzSlider_8.Value=app.Slider_8_Left(app.SS);
            app.AHzSlider_9.Value=app.Slider_9_Left(app.SS);
            app.Switch_1.Value = 'On';
            app.Switch_3.Value = 'Off';
            app.Switch_2.Value = 'Off';
            if app.fitmodel==1
            app.FitmodelButtonPushed;
            end
            app.updateplot;
        end

        % Value changed function: RightEarSwitch
        function RightEarSwitchValueChanged(app, event)
            value = app.RightEarSwitch.Value;
            app.LeftEarSwitch.Value= 'Off';
            app.BothEarsSwitch.Value= 'Off';
            app.RightEarSwitch.Value= 'On';
            app.Lamp_1.Color = [1 0 0];
            app.Lamp_2.Color = [0 1 0];
            app.Lamp_3.Color = [1 0 0]; 
            app.AHzSlider_1.Value=app.Slider_1_Right(app.SS);
            app.AHzSlider_2.Value=app.Slider_2_Right(app.SS);
            app.AHzSlider_3.Value=app.Slider_3_Right(app.SS);
            app.AHzSlider_4.Value=app.Slider_4_Right(app.SS);
            app.AHzSlider_5.Value=app.Slider_5_Right(app.SS);
            app.AHzSlider_6.Value=app.Slider_6_Right(app.SS);
            app.AHzSlider_7.Value=app.Slider_7_Right(app.SS);
            app.AHzSlider_8.Value=app.Slider_8_Right(app.SS);
            app.AHzSlider_9.Value=app.Slider_9_Right(app.SS);
            app.Switch_2.Value = 'On';
            app.Switch_1.Value = 'Off';
            app.Switch_3.Value = 'Off';
            if app.fitmodel==1
            app.FitmodelButtonPushed;
            end
            app.updateplot;
        end

        % Value changed function: Switch_1
        function Switch_1ValueChanged(app, event)

            app.updateplot;
        end

        % Value changed function: Switch_2
        function Switch_2ValueChanged(app, event)
            app.updateplot;
        end

        % Value changed function: Switch_3
        function Switch_3ValueChanged(app, event)

           app.updateplot;
            
        end

        % Button pushed function: SavedataButton
        function SavedataButtonPushed(app, event)
                Age= string(app.AgeEditField.Value);
                Initials= string(app.InitialsEditField.Value);
                expt.initials=app.InitialsEditField.Value;
                mfile_name          = mfilename('fullpath');
                [pathstr,name,ext]  = fileparts(mfile_name);
                cd(pathstr);
                app.filename = strrep(strrep(['DATA_CRITICAL_BANDS/Data_' expt.initials '_' datestr(now) '.xlsx'],' ','_'),':','-');
             
             for i=1:2   
            Thresholds_Both_Ears(i,:)=[app.Slider_1_Both(i) app.Slider_2_Both(i) app.Slider_3_Both(i) app.Slider_4_Both(i)...
            app.Slider_5_Both(i) app.Slider_6_Both(i) app.Slider_7_Both(i) app.Slider_8_Both(i) app.Slider_9_Both(i)]'-app.Knob.Value;
            Thresholds_Left_Ear(i,:)=[app.Slider_1_Left(i) app.Slider_2_Left(i) app.Slider_3_Left(i) app.Slider_4_Left(i)...
            app.Slider_5_Left(i) app.Slider_6_Left(i) app.Slider_7_Left(i) app.Slider_8_Left(i) app.Slider_9_Left(i)]'-app.Knob.Value;
            Thresholds_Right_Ear(i,:)=[app.Slider_1_Right(i) app.Slider_2_Right(i) app.Slider_3_Right(i) app.Slider_4_Right(i)...
            app.Slider_5_Right(i) app.Slider_6_Right(i) app.Slider_7_Right(i) app.Slider_8_Right(i) app.Slider_9_Right(i)]'-app.Knob.Value;
            
             end

            
          Bandwidth_500=[25 50 75 100 150 200 300 400 500]';
          Bandwidth_2000=[50 100 200 250 300 400 600 800 1600]';

                columnName = {'Bandwidth_500';'Thresholds_Both_Ears_500';'Thresholds_Left_Ear_500';'Thresholds_Right_Ear_500'};
                T=table(Bandwidth_500,Thresholds_Both_Ears(1,:)',Thresholds_Left_Ear(1,:)',Thresholds_Right_Ear(1,:)','VariableNames',columnName);
                
                writetable(T,app.filename,'Sheet',1,'Range','A1','WriteVariableNames',true);
                columnName = {'Bandwidth_2000';'Thresholds_Both_Ears_2000';'Thresholds_Left_Ear_2000';'Thresholds_Right_Ear_2000'};
                T=table(Bandwidth_2000,Thresholds_Both_Ears(2,:)',Thresholds_Left_Ear(2,:)',Thresholds_Right_Ear(2,:)','VariableNames',columnName);

                writetable(T,app.filename,'Sheet',1,'Range','E1');

                T=table(Age,Initials);
                writetable(T,app.filename,'Sheet',1,'Range','I1');

                columnName = {'Critical band (Hz)';'Ordinate';'Exponent'};
                LastName={'Thresholds_Both_Ears_500';'Thresholds_Left_Ear_500';'Thresholds_Right_Ear_500';'Thresholds_Both_Ears_2000';'Thresholds_Left_Ear_2000';'Thresholds_Right_Ear_2000'};
                T=table(app.critical_band_final',app.ordinate_final',app.exponent_final','VariableNames',columnName,'RowNames',LastName);
                writetable(T,app.filename,'Sheet',1,'Range','B13','WriteRowNames',true);
                % T=table('RowNames',LastName);
                % writetable(T,app.filename,'Sheet',1,'Range','A14');
 

        end

        % Selection changed function: 
        % TemporalFrequencyofthesignalButtonGroup
        function TemporalFrequencyofthesignalButtonGroupSelectionChanged(app, event)
       %%%     selectedButton = app.TemporalFrequencyofthesignalButtonGroup.SelectedObject;
if app.HzButton_500.Value==1
app.HzLabel_1.Text = '25 Hz';
app.HzLabel_2.Text = '50 Hz';
app.HzLabel_3.Text = '75 Hz';
app.HzLabel_4.Text = '100 Hz';
app.HzLabel_5.Text = '150 Hz';
app.HzLabel_6.Text = '200 Hz';
app.HzLabel_7.Text = '300 Hz';
app.HzLabel_8.Text = '400 Hz';
app.HzLabel_9.Text = '500 Hz';
app.frequency=500;
app.bandwidth=[25 50 75 100 150 200 300 400 500];
            app.UIAxes.XTick = app.bandwidth;
            app.UIAxes.XTickLabel = {'25'; '50'; '75'; '100'; '150'; '200'; '300'; '400'; '500'};
            app.SS=1;
end
if app.HzButton_2000.Value==1
app.HzLabel_1.Text = '50 Hz';
app.HzLabel_2.Text = '100 Hz';
app.HzLabel_3.Text = '200 Hz';
app.HzLabel_4.Text = '250 Hz';
app.HzLabel_5.Text = '300 Hz';
app.HzLabel_6.Text = '400 Hz';
app.HzLabel_7.Text = '600 Hz';
app.HzLabel_8.Text = '800 Hz';
app.HzLabel_9.Text = '1600 Hz';
app.frequency=2000;
app.bandwidth=[50 100 200 250 300 400 600 800 1600];
            app.UIAxes.XTick = app.bandwidth;
            app.UIAxes.XTickLabel = {'50'; '100'; '200'; '250'; '300'; '400'; '600'; '800'; '1600'};
            app.SS=2;
end

          %%%  app.fitmodel=0;
         
if isequaln(app.BothEarsSwitch.Value,'On')==1
            app.AHzSlider_1.Value=app.Slider_1_Both(app.SS);
            app.AHzSlider_2.Value=app.Slider_2_Both(app.SS);
            app.AHzSlider_3.Value=app.Slider_3_Both(app.SS);
            app.AHzSlider_4.Value=app.Slider_4_Both(app.SS);
            app.AHzSlider_5.Value=app.Slider_5_Both(app.SS);
            app.AHzSlider_6.Value=app.Slider_6_Both(app.SS);
            app.AHzSlider_7.Value=app.Slider_7_Both(app.SS);
            app.AHzSlider_8.Value=app.Slider_8_Both(app.SS);
            app.AHzSlider_9.Value=app.Slider_9_Both(app.SS);
end
if isequaln(app.LeftEarSwitch.Value,'On')==1
            app.AHzSlider_1.Value=app.Slider_1_Left(app.SS);
            app.AHzSlider_2.Value=app.Slider_2_Left(app.SS);
            app.AHzSlider_3.Value=app.Slider_3_Left(app.SS);
            app.AHzSlider_4.Value=app.Slider_4_Left(app.SS);
            app.AHzSlider_5.Value=app.Slider_5_Left(app.SS);
            app.AHzSlider_6.Value=app.Slider_6_Left(app.SS);
            app.AHzSlider_7.Value=app.Slider_7_Left(app.SS);
            app.AHzSlider_8.Value=app.Slider_8_Left(app.SS);
            app.AHzSlider_9.Value=app.Slider_9_Left(app.SS);
end
if isequaln(app.RightEarSwitch.Value,'On')==1
            app.AHzSlider_1.Value=app.Slider_1_Right(app.SS);
            app.AHzSlider_2.Value=app.Slider_2_Right(app.SS);
            app.AHzSlider_3.Value=app.Slider_3_Right(app.SS);
            app.AHzSlider_4.Value=app.Slider_4_Right(app.SS);
            app.AHzSlider_5.Value=app.Slider_5_Right(app.SS);
            app.AHzSlider_6.Value=app.Slider_6_Right(app.SS);
            app.AHzSlider_7.Value=app.Slider_7_Right(app.SS);
            app.AHzSlider_8.Value=app.Slider_8_Right(app.SS);
            app.AHzSlider_9.Value=app.Slider_9_Right(app.SS);
end
if app.fitmodel==1
app.FitmodelButtonPushed;
end

            app.updateplot;
        end
    end

    % Component initialization
    methods (Access = private)

        % Create UIFigure and components
        function createComponents(app)

            % Create UIFigure and hide until all components are created
            app.UIFigure = uifigure('Visible', 'off');
            app.UIFigure.AutoResizeChildren = 'off';
            app.UIFigure.Position = [100 100 1171 568];
            app.UIFigure.Name = 'MATLAB App';
            app.UIFigure.Resize = 'off';

            % Create UIAxes
            app.UIAxes = uiaxes(app.UIFigure);
            title(app.UIAxes, 'The Critical Band')
            xlabel(app.UIAxes, 'Temporal frequency (Hz)')
            ylabel(app.UIAxes, 'Signal threshold (dB SPL)')
            zlabel(app.UIAxes, 'Z')
            app.UIAxes.XTick = [];
            app.UIAxes.XTickLabel = '';
            app.UIAxes.Box = 'on';
            app.UIAxes.Visible = 'off';
            app.UIAxes.Position = [750 129 409 235];

            % Create EstimationofthecriticalbandsLabel
            app.EstimationofthecriticalbandsLabel = uilabel(app.UIFigure);
            app.EstimationofthecriticalbandsLabel.FontSize = 18;
            app.EstimationofthecriticalbandsLabel.FontWeight = 'bold';
            app.EstimationofthecriticalbandsLabel.Position = [348 533 275 24];
            app.EstimationofthecriticalbandsLabel.Text = 'Estimation of the critical bands';

            % Create AHzSlider_1
            app.AHzSlider_1 = uislider(app.UIFigure);
            app.AHzSlider_1.Orientation = 'vertical';
            app.AHzSlider_1.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_1ValueChanged, true);
            app.AHzSlider_1.Enable = 'off';
            app.AHzSlider_1.Position = [33 171 3 171];
            app.AHzSlider_1.Value = 100;

            % Create AHzSlider_2
            app.AHzSlider_2 = uislider(app.UIFigure);
            app.AHzSlider_2.Orientation = 'vertical';
            app.AHzSlider_2.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_2ValueChanged, true);
            app.AHzSlider_2.Enable = 'off';
            app.AHzSlider_2.Position = [114 171 3 171];
            app.AHzSlider_2.Value = 100;

            % Create AHzSlider_3
            app.AHzSlider_3 = uislider(app.UIFigure);
            app.AHzSlider_3.Orientation = 'vertical';
            app.AHzSlider_3.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_3ValueChanged, true);
            app.AHzSlider_3.Enable = 'off';
            app.AHzSlider_3.Position = [198 171 3 171];
            app.AHzSlider_3.Value = 100;

            % Create AHzSlider_4
            app.AHzSlider_4 = uislider(app.UIFigure);
            app.AHzSlider_4.Orientation = 'vertical';
            app.AHzSlider_4.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_4ValueChanged, true);
            app.AHzSlider_4.Enable = 'off';
            app.AHzSlider_4.Position = [283 171 3 171];
            app.AHzSlider_4.Value = 100;

            % Create AHzSlider_5
            app.AHzSlider_5 = uislider(app.UIFigure);
            app.AHzSlider_5.Orientation = 'vertical';
            app.AHzSlider_5.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_5ValueChanged, true);
            app.AHzSlider_5.Enable = 'off';
            app.AHzSlider_5.Position = [369 171 3 171];
            app.AHzSlider_5.Value = 100;

            % Create AHzSlider_6
            app.AHzSlider_6 = uislider(app.UIFigure);
            app.AHzSlider_6.Orientation = 'vertical';
            app.AHzSlider_6.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_6ValueChanged, true);
            app.AHzSlider_6.Enable = 'off';
            app.AHzSlider_6.Position = [450 171 3 171];
            app.AHzSlider_6.Value = 100;

            % Create AHzSlider_7
            app.AHzSlider_7 = uislider(app.UIFigure);
            app.AHzSlider_7.Orientation = 'vertical';
            app.AHzSlider_7.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_7ValueChanged, true);
            app.AHzSlider_7.Enable = 'off';
            app.AHzSlider_7.Position = [533 171 3 171];
            app.AHzSlider_7.Value = 100;

            % Create AHzSlider_8
            app.AHzSlider_8 = uislider(app.UIFigure);
            app.AHzSlider_8.Orientation = 'vertical';
            app.AHzSlider_8.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_8ValueChanged, true);
            app.AHzSlider_8.Enable = 'off';
            app.AHzSlider_8.Position = [615 171 3 171];
            app.AHzSlider_8.Value = 100;

            % Create HzLabel_1
            app.HzLabel_1 = uilabel(app.UIFigure);
            app.HzLabel_1.HorizontalAlignment = 'right';
            app.HzLabel_1.Enable = 'off';
            app.HzLabel_1.Position = [32 129 36 22];
            app.HzLabel_1.Text = '25 Hz';

            % Create HzLabel_2
            app.HzLabel_2 = uilabel(app.UIFigure);
            app.HzLabel_2.HorizontalAlignment = 'right';
            app.HzLabel_2.Enable = 'off';
            app.HzLabel_2.Position = [103 129 43 22];
            app.HzLabel_2.Text = ' 50 Hz ';

            % Create HzLabel_3
            app.HzLabel_3 = uilabel(app.UIFigure);
            app.HzLabel_3.HorizontalAlignment = 'right';
            app.HzLabel_3.Enable = 'off';
            app.HzLabel_3.Position = [188 129 43 22];
            app.HzLabel_3.Text = ' 75 Hz ';

            % Create HzLabel_4
            app.HzLabel_4 = uilabel(app.UIFigure);
            app.HzLabel_4.HorizontalAlignment = 'right';
            app.HzLabel_4.Enable = 'off';
            app.HzLabel_4.Position = [275 129 43 22];
            app.HzLabel_4.Text = '100 Hz';

            % Create HzLabel_5
            app.HzLabel_5 = uilabel(app.UIFigure);
            app.HzLabel_5.HorizontalAlignment = 'right';
            app.HzLabel_5.Enable = 'off';
            app.HzLabel_5.Position = [364 129 43 22];
            app.HzLabel_5.Text = '150 Hz';

            % Create HzLabel_6
            app.HzLabel_6 = uilabel(app.UIFigure);
            app.HzLabel_6.HorizontalAlignment = 'right';
            app.HzLabel_6.Enable = 'off';
            app.HzLabel_6.Position = [445 129 43 22];
            app.HzLabel_6.Text = '200 Hz';

            % Create HzLabel_7
            app.HzLabel_7 = uilabel(app.UIFigure);
            app.HzLabel_7.HorizontalAlignment = 'right';
            app.HzLabel_7.Enable = 'off';
            app.HzLabel_7.Position = [530 129 43 22];
            app.HzLabel_7.Text = '300 Hz';

            % Create HzLabel_8
            app.HzLabel_8 = uilabel(app.UIFigure);
            app.HzLabel_8.HorizontalAlignment = 'right';
            app.HzLabel_8.Enable = 'off';
            app.HzLabel_8.Position = [609 129 43 22];
            app.HzLabel_8.Text = '400 Hz';

            % Create AdjusttheslideruntilyoudonthearthesignalinsertedinnoiseLabel
            app.AdjusttheslideruntilyoudonthearthesignalinsertedinnoiseLabel = uilabel(app.UIFigure);
            app.AdjusttheslideruntilyoudonthearthesignalinsertedinnoiseLabel.Enable = 'off';
            app.AdjusttheslideruntilyoudonthearthesignalinsertedinnoiseLabel.Position = [244 363 349 22];
            app.AdjusttheslideruntilyoudonthearthesignalinsertedinnoiseLabel.Text = 'Adjust the slider until you don''t hear the signal inserted in noise';

            % Create BandwidthofthebandpassnoiseLabel
            app.BandwidthofthebandpassnoiseLabel = uilabel(app.UIFigure);
            app.BandwidthofthebandpassnoiseLabel.FontSize = 14;
            app.BandwidthofthebandpassnoiseLabel.Enable = 'off';
            app.BandwidthofthebandpassnoiseLabel.Position = [297 100 222 22];
            app.BandwidthofthebandpassnoiseLabel.Text = 'Bandwidth of the band-pass noise';

            % Create Knob
            app.Knob = uiknob(app.UIFigure, 'continuous');
            app.Knob.ValueChangedFcn = createCallbackFcn(app, @KnobValueChanged, true);
            app.Knob.Position = [184 444 60 60];
            app.Knob.Value = 50;

            % Create AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel = uilabel(app.UIFigure);
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.HorizontalAlignment = 'center';
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.WordWrap = 'on';
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.Position = [17 452 127 44];
            app.AdjustthevolumemovingtheknobsothesoundisbarelyaudibleLabel.Text = 'Adjust the volume moving the knob so the sound is barely audible';

            % Create VolumecalibrationLabel
            app.VolumecalibrationLabel = uilabel(app.UIFigure);
            app.VolumecalibrationLabel.Position = [166 532 116 27];
            app.VolumecalibrationLabel.Text = 'Volume calibration';

            % Create PressthisbuttonwhenreadyButton
            app.PressthisbuttonwhenreadyButton = uibutton(app.UIFigure, 'push');
            app.PressthisbuttonwhenreadyButton.ButtonPushedFcn = createCallbackFcn(app, @PressthisbuttonwhenreadyButtonPushed, true);
            app.PressthisbuttonwhenreadyButton.WordWrap = 'on';
            app.PressthisbuttonwhenreadyButton.Position = [297 444 80 52];
            app.PressthisbuttonwhenreadyButton.Text = 'Press this button when ready';

            % Create RecalibratevolumeButton
            app.RecalibratevolumeButton = uibutton(app.UIFigure, 'push');
            app.RecalibratevolumeButton.ButtonPushedFcn = createCallbackFcn(app, @RecalibratevolumeButtonPushed, true);
            app.RecalibratevolumeButton.Enable = 'off';
            app.RecalibratevolumeButton.Position = [25 32 118 23];
            app.RecalibratevolumeButton.Text = 'Recalibrate volume';

            % Create LeftEarSwitchLabel
            app.LeftEarSwitchLabel = uilabel(app.UIFigure);
            app.LeftEarSwitchLabel.HorizontalAlignment = 'center';
            app.LeftEarSwitchLabel.Enable = 'off';
            app.LeftEarSwitchLabel.Position = [525 478 47 22];
            app.LeftEarSwitchLabel.Text = 'Left Ear';

            % Create LeftEarSwitch
            app.LeftEarSwitch = uiswitch(app.UIFigure, 'slider');
            app.LeftEarSwitch.ValueChangedFcn = createCallbackFcn(app, @LeftEarSwitchValueChanged, true);
            app.LeftEarSwitch.Enable = 'off';
            app.LeftEarSwitch.Position = [446 479 45 20];

            % Create RightEarSwitchLabel
            app.RightEarSwitchLabel = uilabel(app.UIFigure);
            app.RightEarSwitchLabel.HorizontalAlignment = 'center';
            app.RightEarSwitchLabel.Enable = 'off';
            app.RightEarSwitchLabel.Position = [525 449 54 22];
            app.RightEarSwitchLabel.Text = 'Right Ear';

            % Create RightEarSwitch
            app.RightEarSwitch = uiswitch(app.UIFigure, 'slider');
            app.RightEarSwitch.ValueChangedFcn = createCallbackFcn(app, @RightEarSwitchValueChanged, true);
            app.RightEarSwitch.Enable = 'off';
            app.RightEarSwitch.Position = [446 450 45 20];

            % Create BothEarsSwitchLabel
            app.BothEarsSwitchLabel = uilabel(app.UIFigure);
            app.BothEarsSwitchLabel.HorizontalAlignment = 'center';
            app.BothEarsSwitchLabel.Enable = 'off';
            app.BothEarsSwitchLabel.Position = [524 421 58 22];
            app.BothEarsSwitchLabel.Text = 'Both Ears';

            % Create BothEarsSwitch
            app.BothEarsSwitch = uiswitch(app.UIFigure, 'slider');
            app.BothEarsSwitch.ValueChangedFcn = createCallbackFcn(app, @BothEarsSwitchValueChanged, true);
            app.BothEarsSwitch.Enable = 'off';
            app.BothEarsSwitch.Position = [447 422 45 20];
            app.BothEarsSwitch.Value = 'On';

            % Create Lamp_1
            app.Lamp_1 = uilamp(app.UIFigure);
            app.Lamp_1.Enable = 'off';
            app.Lamp_1.Position = [397 424 20 20];

            % Create Lamp_2
            app.Lamp_2 = uilamp(app.UIFigure);
            app.Lamp_2.Enable = 'off';
            app.Lamp_2.Position = [397 452 20 20];
            app.Lamp_2.Color = [1 0 0];

            % Create Lamp_3
            app.Lamp_3 = uilamp(app.UIFigure);
            app.Lamp_3.Enable = 'off';
            app.Lamp_3.Position = [397 479 20 20];
            app.Lamp_3.Color = [1 0 0];

            % Create RestartButton
            app.RestartButton = uibutton(app.UIFigure, 'push');
            app.RestartButton.ButtonPushedFcn = createCallbackFcn(app, @RestartButtonPushed, true);
            app.RestartButton.Enable = 'off';
            app.RestartButton.Position = [174 32 100 23];
            app.RestartButton.Text = 'Restart';

            % Create ShowdataLabel
            app.ShowdataLabel = uilabel(app.UIFigure);
            app.ShowdataLabel.FontWeight = 'bold';
            app.ShowdataLabel.Position = [650 503 77 22];
            app.ShowdataLabel.Text = 'Show data';

            % Create Switch_1
            app.Switch_1 = uiswitch(app.UIFigure, 'slider');
            app.Switch_1.ValueChangedFcn = createCallbackFcn(app, @Switch_1ValueChanged, true);
            app.Switch_1.Enable = 'off';
            app.Switch_1.Position = [660 476 45 20];

            % Create Switch_2
            app.Switch_2 = uiswitch(app.UIFigure, 'slider');
            app.Switch_2.ValueChangedFcn = createCallbackFcn(app, @Switch_2ValueChanged, true);
            app.Switch_2.Enable = 'off';
            app.Switch_2.Position = [659 450 45 20];

            % Create Switch_3
            app.Switch_3 = uiswitch(app.UIFigure, 'slider');
            app.Switch_3.ValueChangedFcn = createCallbackFcn(app, @Switch_3ValueChanged, true);
            app.Switch_3.Enable = 'off';
            app.Switch_3.Position = [659 422 45 20];
            app.Switch_3.Value = 'On';

            % Create StimuluspresentationLabel
            app.StimuluspresentationLabel = uilabel(app.UIFigure);
            app.StimuluspresentationLabel.FontWeight = 'bold';
            app.StimuluspresentationLabel.Position = [432 503 130 22];
            app.StimuluspresentationLabel.Text = 'Stimulus presentation';

            % Create SavedataButton
            app.SavedataButton = uibutton(app.UIFigure, 'push');
            app.SavedataButton.ButtonPushedFcn = createCallbackFcn(app, @SavedataButtonPushed, true);
            app.SavedataButton.FontWeight = 'bold';
            app.SavedataButton.Enable = 'off';
            app.SavedataButton.Position = [660 54 100 23];
            app.SavedataButton.Text = 'Save data';

            % Create InitialsEditFieldLabel
            app.InitialsEditFieldLabel = uilabel(app.UIFigure);
            app.InitialsEditFieldLabel.HorizontalAlignment = 'right';
            app.InitialsEditFieldLabel.Enable = 'off';
            app.InitialsEditFieldLabel.Position = [520 71 39 22];
            app.InitialsEditFieldLabel.Text = 'Initials';

            % Create InitialsEditField
            app.InitialsEditField = uieditfield(app.UIFigure, 'text');
            app.InitialsEditField.Enable = 'off';
            app.InitialsEditField.Position = [574 71 75 22];

            % Create AgeEditFieldLabel
            app.AgeEditFieldLabel = uilabel(app.UIFigure);
            app.AgeEditFieldLabel.HorizontalAlignment = 'right';
            app.AgeEditFieldLabel.Enable = 'off';
            app.AgeEditFieldLabel.Position = [530 37 26 22];
            app.AgeEditFieldLabel.Text = 'Age';

            % Create AgeEditField
            app.AgeEditField = uieditfield(app.UIFigure, 'text');
            app.AgeEditField.CharacterLimits = [0 150];
            app.AgeEditField.InputType = 'digits';
            app.AgeEditField.Enable = 'off';
            app.AgeEditField.Position = [575 37 74 22];

            % Create SerranoPedrazaI2023Label
            app.SerranoPedrazaI2023Label = uilabel(app.UIFigure);
            app.SerranoPedrazaI2023Label.FontSize = 9;
            app.SerranoPedrazaI2023Label.Position = [6 1 110 22];
            app.SerranoPedrazaI2023Label.Text = 'Serrano-Pedraza, I. (2023)';

            % Create TemporalFrequencyofthesignalButtonGroup
            app.TemporalFrequencyofthesignalButtonGroup = uibuttongroup(app.UIFigure);
            app.TemporalFrequencyofthesignalButtonGroup.AutoResizeChildren = 'off';
            app.TemporalFrequencyofthesignalButtonGroup.SelectionChangedFcn = createCallbackFcn(app, @TemporalFrequencyofthesignalButtonGroupSelectionChanged, true);
            app.TemporalFrequencyofthesignalButtonGroup.Enable = 'off';
            app.TemporalFrequencyofthesignalButtonGroup.Title = 'Temporal Frequency of the signal';
            app.TemporalFrequencyofthesignalButtonGroup.Position = [869 394 193 74];

            % Create HzButton_500
            app.HzButton_500 = uiradiobutton(app.TemporalFrequencyofthesignalButtonGroup);
            app.HzButton_500.Enable = 'off';
            app.HzButton_500.Text = '500 Hz';
            app.HzButton_500.Position = [11 28 60 22];
            app.HzButton_500.Value = true;

            % Create HzButton_2000
            app.HzButton_2000 = uiradiobutton(app.TemporalFrequencyofthesignalButtonGroup);
            app.HzButton_2000.Enable = 'off';
            app.HzButton_2000.Text = '2000 Hz';
            app.HzButton_2000.Position = [11 6 66 22];

            % Create AHzSlider_9
            app.AHzSlider_9 = uislider(app.UIFigure);
            app.AHzSlider_9.Orientation = 'vertical';
            app.AHzSlider_9.ValueChangedFcn = createCallbackFcn(app, @AHzSlider_9ValueChanged, true);
            app.AHzSlider_9.Enable = 'off';
            app.AHzSlider_9.Position = [696 171 3 171];
            app.AHzSlider_9.Value = 100;

            % Create HzLabel_9
            app.HzLabel_9 = uilabel(app.UIFigure);
            app.HzLabel_9.HorizontalAlignment = 'right';
            app.HzLabel_9.Enable = 'off';
            app.HzLabel_9.Position = [684 129 49 22];
            app.HzLabel_9.Text = ' 500 Hz ';

            % Create FitmodelButton
            app.FitmodelButton = uibutton(app.UIFigure, 'push');
            app.FitmodelButton.ButtonPushedFcn = createCallbackFcn(app, @FitmodelButtonPushed, true);
            app.FitmodelButton.FontWeight = 'bold';
            app.FitmodelButton.Enable = 'off';
            app.FitmodelButton.Position = [881 54 100 23];
            app.FitmodelButton.Text = 'Fit model';

            % Create FitthemodelwhentheexperimentisfinishedLabel
            app.FitthemodelwhentheexperimentisfinishedLabel = uilabel(app.UIFigure);
            app.FitthemodelwhentheexperimentisfinishedLabel.HorizontalAlignment = 'center';
            app.FitthemodelwhentheexperimentisfinishedLabel.WordWrap = 'on';
            app.FitthemodelwhentheexperimentisfinishedLabel.Position = [856 11 152 44];
            app.FitthemodelwhentheexperimentisfinishedLabel.Text = 'Fit the model when the experiment is finished.';

            % Create RemovefittingButton
            app.RemovefittingButton = uibutton(app.UIFigure, 'push');
            app.RemovefittingButton.ButtonPushedFcn = createCallbackFcn(app, @RemovefittingButtonPushed, true);
            app.RemovefittingButton.FontWeight = 'bold';
            app.RemovefittingButton.Enable = 'off';
            app.RemovefittingButton.Position = [1009 54 100 23];
            app.RemovefittingButton.Text = 'Remove fitting';

            % Show the figure after all components are created
            app.UIFigure.Visible = 'on';
        end
    end

    % App creation and deletion
    methods (Access = public)

        % Construct app
        function app = Experiment_Critical_Bands

            % Create UIFigure and components
            createComponents(app)

            % Register the app with App Designer
            registerApp(app, app.UIFigure)

            if nargout == 0
                clear app
            end
        end

        % Code that executes before app deletion
        function delete(app)

            % Delete UIFigure when app is deleted
            delete(app.UIFigure)
        end
    end
end