classdef Loudness_Part_2 < matlab.apps.AppBase

    % Properties that correspond to app components
    properties (Access = public)
        UIFigure                     matlab.ui.Figure
        StevensconstantLabel         matlab.ui.control.Label
        EstimationscanbeeditedLabel  matlab.ui.control.Label
        LinearregressionLabel        matlab.ui.control.Label
        StevensexponentLabel         matlab.ui.control.Label
        bEditField                   matlab.ui.control.NumericEditField
        bEditFieldLabel              matlab.ui.control.Label
        aEditField                   matlab.ui.control.NumericEditField
        aEditFieldLabel              matlab.ui.control.Label
        StevensparametersLabel       matlab.ui.control.Label
        BEditField                   matlab.ui.control.NumericEditField
        BEditFieldLabel              matlab.ui.control.Label
        AEditField                   matlab.ui.control.NumericEditField
        AEditFieldLabel              matlab.ui.control.Label
        SumNxlogLEditField           matlab.ui.control.NumericEditField
        SumNxlogLEditFieldLabel      matlab.ui.control.Label
        SumN2EditField               matlab.ui.control.NumericEditField
        SumN2EditFieldLabel          matlab.ui.control.Label
        SumlogLEditField             matlab.ui.control.NumericEditField
        SumlogLEditFieldLabel        matlab.ui.control.Label
        SumNEditField                matlab.ui.control.NumericEditField
        SumNEditFieldLabel           matlab.ui.control.Label
        nEditField                   matlab.ui.control.NumericEditField
        nEditFieldLabel              matlab.ui.control.Label
        SaveanalysisButton           matlab.ui.control.Button
        SerranoPedrazaI2023Label     matlab.ui.control.Label
        LoaddatafileButton           matlab.ui.control.Button
        UITable                      matlab.ui.control.Table
        AnalysisofloudnessestimationLabel  matlab.ui.control.Label
        UIAxes2                      matlab.ui.control.UIAxes
        UIAxes                       matlab.ui.control.UIAxes
    end

    
    properties (Access = public)
        filename; % Description
    end
    
    properties (Access = private)
        CallingApp; % Main app 
        Indices;
    end
    
    
    
    methods (Access = private)
        
        function updateplot(app)
           
            %%Dr. Ignacio Serrano-Pedraza 2023
            %%%With this program you can analyze the data from the
            %%%experiment Experiment_Stevens_Loudness.m

            % Get Table UI component data
             t = app.UITable.DisplayData;            
            Trials=t.Trials;
            Estimations=t.Estimations;
            Difference_in_dB=t.Difference_in_dB;
            L=Estimations*0.48/100;%%%sones
            logL=log10(L);
            N=Difference_in_dB+30;
            N2=N.^2;
            NlogL=N.*logL;

            T=table(Trials,Difference_in_dB,N,Estimations,L,logL,N2,NlogL);

            app.UITable.Data = T;

             x2 = t.Difference_in_dB+30;
             y2 = t.Estimations*0.48/100;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
              app.nEditField.Value= length(x2);
              app.SumNEditField.Value=sum(x2);
              app.SumlogLEditField.Value=sum(log10(y2));
              app.SumN2EditField.Value=sum(x2.^2);
              app.SumNxlogLEditField.Value=sum(x2.*log10(y2));

              %%%Linear regression
              app.AEditField.Value=(app.nEditField.Value*app.SumNxlogLEditField.Value-app.SumNEditField.Value*app.SumlogLEditField.Value)...
                  /(app.nEditField.Value*app.SumN2EditField.Value-app.SumNEditField.Value^2);
              app.BEditField.Value=mean(log10(y2))-app.AEditField.Value*mean(x2);


              app.aEditField.Value=app.AEditField.Value*20;
              app.bEditField.Value=(10^app.BEditField.Value)/0.0002^app.aEditField.Value;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            % % Plot data 
             
              semilogy(app.UIAxes,x2,y2,'ko')
              hold(app.UIAxes,'on');
              x4=[5:1:55];
              y4=10.^(app.AEditField.Value*x4+app.BEditField.Value);
              semilogy(app.UIAxes,x4,y4,'k-','Linewidth',2)
              axis(app.UIAxes,[5 55 0.01 5])
              hold(app.UIAxes,'off');

              xx2 = 0.0002*10.^((x2)/20);
              yy2 = t.Estimations*0.48/100;
              plot(app.UIAxes2,xx2,yy2,'ko')
              hold(app.UIAxes2,'on');
              xx4=0.0002*10.^([5:1:55]/20);
              yy4=app.bEditField.Value*(xx4).^app.aEditField.Value;
              plot(app.UIAxes2,xx4,yy4,'k-','Linewidth',2)
              axis(app.UIAxes2,[0 0.07 0.01 3])
              hold(app.UIAxes2,'off');

                if isempty(app.Indices)==0
              x3 = t.Difference_in_dB(unique(app.Indices(:,1)))+30;
              y3 = t.Estimations(unique(app.Indices(:,1)))*0.48/100;
              semilogy(app.UIAxes,x2,y2,'ko','MarkerSize',8)
              hold(app.UIAxes,'on');
              semilogy(app.UIAxes,x3,y3,'ro','Linewidth',2,'MarkerSize',8)
              hold(app.UIAxes,'on');
              x4=[5:1:55];
              y4=10.^(app.AEditField.Value*x4+app.BEditField.Value);
              semilogy(app.UIAxes,x4,y4,'k-','Linewidth',2)
              axis(app.UIAxes,[5 55 0.01 5])
              hold(app.UIAxes,'off');

              xx3 = 0.0002*10.^((x2(unique(app.Indices(:,1))))/20);
              yy3 = t.Estimations(unique(app.Indices(:,1)))*0.48/100;
              plot(app.UIAxes2,xx2,yy2,'ko','MarkerSize',8)
              hold(app.UIAxes2,'on');
              plot(app.UIAxes2,xx3,yy3,'ro','Linewidth',2,'MarkerSize',8)
              hold(app.UIAxes2,'on');
              xx4=0.0002*10.^([5:1:55]/20);
              yy4=app.bEditField.Value*(xx4).^app.aEditField.Value;
              plot(app.UIAxes2,xx4,yy4,'k-','Linewidth',2)
              axis(app.UIAxes2,[0 0.07 0.01 3])
              hold(app.UIAxes2,'off');
                end
        end
    end
    

    % Callbacks that handle component events
    methods (Access = private)

        % Code that executes after component creation
        function startupFcn(app, caller, namefile)
        

            if isempty(app.filename)==0
            % Read table array from file
            t = readtable(app.filename);
            Trials=t.Trials;
            Estimations=t.Estimations;
            Difference_in_dB=t.Difference_in_dB;
            L=Estimations*0.48/100;%%%sones
            logL=log10(L);
            N=Difference_in_dB+30;
            N2=N.^2;
            NlogL=N.*logL;

            T=table(Trials,Difference_in_dB,N,Estimations,L,logL,N2,NlogL);

            app.UITable.Data = T;
            app.updateplot;
            else
            %%%app.CallingApp = caller; 
            app.filename=namefile;  
            % Read table array from file
            t = readtable(app.filename);
            Trials=t.Trials;
            Estimations=t.Estimations;
            Difference_in_dB=t.Difference_in_dB;
            L=Estimations*0.48/100;%%%sones
            logL=log10(L);
            N=Difference_in_dB+30;
            N2=N.^2;
            NlogL=N.*logL;

            T=table(Trials,Difference_in_dB,N,Estimations,L,logL,N2,NlogL);


            app.UITable.Data = T;
            app.updateplot;
            end
        end

        % Button pushed function: LoaddatafileButton
        function LoaddatafileButtonPushed(app, event)
           
            mfile_name          = mfilename('fullpath');
            [pathstr,name,ext]  = fileparts(mfile_name);
            cd(pathstr);
            app.UIFigure.Visible = 'off';
            [filename,pathname] = uigetfile('*.xlsx');
            app.UIFigure.Visible = 'on';

            if isequal(filename,0) || isequal(pathname,0)
            disp('User pressed cancel')
            else
            disp(['User selected ', fullfile(pathname, filename)])
            app.filename= fullfile(pathname,filename);
            
            app.startupFcn;
             
            end
        end

        % Display data changed function: UITable
        function UITableDisplayDataChanged(app, event)
            %newDisplayData = app.UITable.DisplayData;
            app.updateplot;
        end

        % Cell selection callback: UITable
        function UITableCellSelection(app, event)
          app.Indices=event.Indices;
          app.updateplot;
        end

        % Button pushed function: SaveanalysisButton
        function SaveanalysisButtonPushed(app, event)
            t = app.UITable.DisplayData;  
            Trials=t.Trials;
            Estimations=t.Estimations;
            Difference_in_dB=t.Difference_in_dB;
            L=Estimations*0.48/100;%%%sones
            logL=log10(L);
            N=Difference_in_dB+30;
            N2=N.^2;
            NlogL=N.*logL;
            t = readtable(app.filename);
            Age=t.Age;
            Initials=t.Initials;

            T=table(Trials,Difference_in_dB,N,Estimations,L,logL,N2,NlogL,Age,Initials);


            [pathstr,name,ext]  = fileparts(app.filename);
            name=[name '_copy' ext];
            filename= fullfile(pathstr,name);

            writetable(T,filename,'Sheet',1,'Range','A1');

            Stevens_exponent=app.aEditField.Value;
            Constant=app.bEditField.Value;
            T=table(Stevens_exponent,Constant);
            writetable(T,filename,'Sheet',1,'Range','K1');
        end
    end

    % Component initialization
    methods (Access = private)

        % Create UIFigure and components
        function createComponents(app)

            % Create UIFigure and hide until all components are created
            app.UIFigure = uifigure('Visible', 'off');
            app.UIFigure.Position = [100 100 831 563];
            app.UIFigure.Name = 'MATLAB App';

            % Create UIAxes
            app.UIAxes = uiaxes(app.UIFigure);
            title(app.UIAxes, 'Loudness estimation. Log-scale')
            xlabel(app.UIAxes, 'Sound Pressure Level (dB SPL)')
            ylabel(app.UIAxes, 'Loudness (sones)')
            zlabel(app.UIAxes, 'Z')
            app.UIAxes.Box = 'on';
            app.UIAxes.XGrid = 'on';
            app.UIAxes.YGrid = 'on';
            app.UIAxes.Position = [446 305 360 199];

            % Create UIAxes2
            app.UIAxes2 = uiaxes(app.UIFigure);
            title(app.UIAxes2, 'Loudness estimation. Linear-scale')
            xlabel(app.UIAxes2, 'Sound Pressure, P (dinas/cm^2)')
            ylabel(app.UIAxes2, 'Loudness (sones)')
            zlabel(app.UIAxes2, 'Z')
            app.UIAxes2.Box = 'on';
            app.UIAxes2.XGrid = 'on';
            app.UIAxes2.YGrid = 'on';
            app.UIAxes2.Position = [446 72 360 196];

            % Create AnalysisofloudnessestimationLabel
            app.AnalysisofloudnessestimationLabel = uilabel(app.UIFigure);
            app.AnalysisofloudnessestimationLabel.FontSize = 14;
            app.AnalysisofloudnessestimationLabel.FontWeight = 'bold';
            app.AnalysisofloudnessestimationLabel.Position = [296 531 217 22];
            app.AnalysisofloudnessestimationLabel.Text = 'Analysis of loudness estimation';

            % Create UITable
            app.UITable = uitable(app.UIFigure);
            app.UITable.ColumnName = {'Trials'; 'Diff. in dB'; 'N'; 'Estimations*'; 'L(sones)'; 'logL'; 'N^2'; 'N*logL'};
            app.UITable.ColumnWidth = {'fit'};
            app.UITable.RowName = {};
            app.UITable.ColumnEditable = [false false false true false false false false];
            app.UITable.CellSelectionCallback = createCallbackFcn(app, @UITableCellSelection, true);
            app.UITable.DisplayDataChangedFcn = createCallbackFcn(app, @UITableDisplayDataChanged, true);
            app.UITable.Position = [30 249 381 255];

            % Create LoaddatafileButton
            app.LoaddatafileButton = uibutton(app.UIFigure, 'push');
            app.LoaddatafileButton.ButtonPushedFcn = createCallbackFcn(app, @LoaddatafileButtonPushed, true);
            app.LoaddatafileButton.FontSize = 14;
            app.LoaddatafileButton.Position = [30 516 100 25];
            app.LoaddatafileButton.Text = 'Load data file';

            % Create SerranoPedrazaI2023Label
            app.SerranoPedrazaI2023Label = uilabel(app.UIFigure);
            app.SerranoPedrazaI2023Label.FontSize = 9;
            app.SerranoPedrazaI2023Label.Position = [9 8 110 22];
            app.SerranoPedrazaI2023Label.Text = 'Serrano-Pedraza, I. (2023)';

            % Create SaveanalysisButton
            app.SaveanalysisButton = uibutton(app.UIFigure, 'push');
            app.SaveanalysisButton.ButtonPushedFcn = createCallbackFcn(app, @SaveanalysisButtonPushed, true);
            app.SaveanalysisButton.Position = [129 216 130 23];
            app.SaveanalysisButton.Text = 'Save analysis';

            % Create nEditFieldLabel
            app.nEditFieldLabel = uilabel(app.UIFigure);
            app.nEditFieldLabel.HorizontalAlignment = 'right';
            app.nEditFieldLabel.FontAngle = 'italic';
            app.nEditFieldLabel.Position = [47 179 25 22];
            app.nEditFieldLabel.Text = 'n';

            % Create nEditField
            app.nEditField = uieditfield(app.UIFigure, 'numeric');
            app.nEditField.Editable = 'off';
            app.nEditField.HorizontalAlignment = 'center';
            app.nEditField.Position = [51 160 38 21];

            % Create SumNEditFieldLabel
            app.SumNEditFieldLabel = uilabel(app.UIFigure);
            app.SumNEditFieldLabel.HorizontalAlignment = 'right';
            app.SumNEditFieldLabel.Position = [111 180 45 22];
            app.SumNEditFieldLabel.Text = 'Sum(N)';

            % Create SumNEditField
            app.SumNEditField = uieditfield(app.UIFigure, 'numeric');
            app.SumNEditField.Editable = 'off';
            app.SumNEditField.Position = [109 160 50 21];

            % Create SumlogLEditFieldLabel
            app.SumlogLEditFieldLabel = uilabel(app.UIFigure);
            app.SumlogLEditFieldLabel.HorizontalAlignment = 'right';
            app.SumlogLEditFieldLabel.Position = [176 180 59 22];
            app.SumlogLEditFieldLabel.Text = 'Sum(logL)';

            % Create SumlogLEditField
            app.SumlogLEditField = uieditfield(app.UIFigure, 'numeric');
            app.SumlogLEditField.ValueDisplayFormat = '%.3f';
            app.SumlogLEditField.Editable = 'off';
            app.SumlogLEditField.Position = [181 160 50 21];

            % Create SumN2EditFieldLabel
            app.SumN2EditFieldLabel = uilabel(app.UIFigure);
            app.SumN2EditFieldLabel.HorizontalAlignment = 'right';
            app.SumN2EditFieldLabel.Position = [253 179 58 22];
            app.SumN2EditFieldLabel.Text = 'Sum(N^2)';

            % Create SumN2EditField
            app.SumN2EditField = uieditfield(app.UIFigure, 'numeric');
            app.SumN2EditField.ValueDisplayFormat = '%.3f';
            app.SumN2EditField.Editable = 'off';
            app.SumN2EditField.Position = [243 159 78 21];

            % Create SumNxlogLEditFieldLabel
            app.SumNxlogLEditFieldLabel = uilabel(app.UIFigure);
            app.SumNxlogLEditFieldLabel.HorizontalAlignment = 'right';
            app.SumNxlogLEditFieldLabel.Position = [335 180 74 22];
            app.SumNxlogLEditFieldLabel.Text = 'Sum(NxlogL)';

            % Create SumNxlogLEditField
            app.SumNxlogLEditField = uieditfield(app.UIFigure, 'numeric');
            app.SumNxlogLEditField.ValueDisplayFormat = '%.3f';
            app.SumNxlogLEditField.Editable = 'off';
            app.SumNxlogLEditField.Position = [332 158 79 21];

            % Create AEditFieldLabel
            app.AEditFieldLabel = uilabel(app.UIFigure);
            app.AEditFieldLabel.HorizontalAlignment = 'right';
            app.AEditFieldLabel.Position = [30 96 25 22];
            app.AEditFieldLabel.Text = 'A';

            % Create AEditField
            app.AEditField = uieditfield(app.UIFigure, 'numeric');
            app.AEditField.ValueDisplayFormat = '%.3f';
            app.AEditField.Editable = 'off';
            app.AEditField.Position = [63 96 50 21];

            % Create BEditFieldLabel
            app.BEditFieldLabel = uilabel(app.UIFigure);
            app.BEditFieldLabel.HorizontalAlignment = 'right';
            app.BEditFieldLabel.Position = [30 61 25 22];
            app.BEditFieldLabel.Text = 'B';

            % Create BEditField
            app.BEditField = uieditfield(app.UIFigure, 'numeric');
            app.BEditField.ValueDisplayFormat = '%.3f';
            app.BEditField.Editable = 'off';
            app.BEditField.Position = [63 61 50 21];

            % Create StevensparametersLabel
            app.StevensparametersLabel = uilabel(app.UIFigure);
            app.StevensparametersLabel.FontSize = 14;
            app.StevensparametersLabel.Position = [206 102 134 22];
            app.StevensparametersLabel.Text = 'Stevens'' parameters';

            % Create aEditFieldLabel
            app.aEditFieldLabel = uilabel(app.UIFigure);
            app.aEditFieldLabel.HorizontalAlignment = 'right';
            app.aEditFieldLabel.Position = [221 75 25 22];
            app.aEditFieldLabel.Text = 'a';

            % Create aEditField
            app.aEditField = uieditfield(app.UIFigure, 'numeric');
            app.aEditField.ValueDisplayFormat = '%.3f';
            app.aEditField.Editable = 'off';
            app.aEditField.Position = [254 75 50 21];

            % Create bEditFieldLabel
            app.bEditFieldLabel = uilabel(app.UIFigure);
            app.bEditFieldLabel.HorizontalAlignment = 'right';
            app.bEditFieldLabel.Position = [221 45 25 22];
            app.bEditFieldLabel.Text = 'b';

            % Create bEditField
            app.bEditField = uieditfield(app.UIFigure, 'numeric');
            app.bEditField.ValueDisplayFormat = '%.3f';
            app.bEditField.Editable = 'off';
            app.bEditField.Position = [254 45 50 21];

            % Create StevensexponentLabel
            app.StevensexponentLabel = uilabel(app.UIFigure);
            app.StevensexponentLabel.Position = [311 74 111 22];
            app.StevensexponentLabel.Text = '(Stevens'' exponent)';

            % Create LinearregressionLabel
            app.LinearregressionLabel = uilabel(app.UIFigure);
            app.LinearregressionLabel.FontSize = 14;
            app.LinearregressionLabel.Position = [30 123 112 22];
            app.LinearregressionLabel.Text = 'Linear regression';

            % Create EstimationscanbeeditedLabel
            app.EstimationscanbeeditedLabel = uilabel(app.UIFigure);
            app.EstimationscanbeeditedLabel.FontSize = 10;
            app.EstimationscanbeeditedLabel.Position = [288 228 124 22];
            app.EstimationscanbeeditedLabel.Text = '*Estimations can be edited';

            % Create StevensconstantLabel
            app.StevensconstantLabel = uilabel(app.UIFigure);
            app.StevensconstantLabel.Position = [314 45 108 22];
            app.StevensconstantLabel.Text = '(Stevens'' constant)';

            % Show the figure after all components are created
            app.UIFigure.Visible = 'on';
        end
    end

    % App creation and deletion
    methods (Access = public)

        % Construct app
        function app = Loudness_Part_2(varargin)

            % Create UIFigure and components
            createComponents(app)

            % Register the app with App Designer
            registerApp(app, app.UIFigure)

            % Execute the startup function
            runStartupFcn(app, @(app)startupFcn(app, varargin{:}))

            if nargout == 0
                clear app
            end
        end

        % Code that executes before app deletion
        function delete(app)

            % Delete UIFigure when app is deleted
            delete(app.UIFigure)
        end
    end
end